﻿﻿include("Objects/DpEval.js");
include("Objects/DpGetDat.js");
include("Objects/DpJournal.js");
include("doc/DpDoc.js");

var m_File;
var m_Reg;
var m_Vid;
var m_Doc;
var m_Nop;
var m_Id_doc;
var m_Id_contr;
var sDocregTbl;

var SUM20, SUM20D, SUM20T;
var SUM00, SUM00D, SUM00T;
var SUMXX;
var SUMA0;
var SUMB0;
var SUME0;
var SUMPNIM20;
var SUMPNDS, SUMPNDSD, SUMPNDST;
var SUMPNND;
var SUMPNIMND;
var SUMPN00;
var SUMPNIM00;
var SUMU;
var SUMND;
var SUMNA;
var SUM_ALL, SUM_ALL_D, SUM_ALL_K;

function initSumFields(sType)
{
	if (sType=="-")
	{
		SUM20D = "^HDPO20+^HDVO20+^HDPOSNDS+^HDVOSNDS-round(^HDPOSNDS/6+^HDVOSNDS/6,2)";
		SUM20T = "^HTPO20+^HTVO20+^HTPOSNDS+^HTVOSNDS-round(^HTPOSNDS/6+^HTVOSNDS/6,2)";
		SUM20 = SUM20D + "+" + SUM20T + "+^HTSO20";

		SUM00 = "^HDPO00+^HTPO00+^HTSO00+^HDVO00+^HTVO00"
		SUM00T = "^HTPO00+^HTVO00+^HTPOA0";
		SUM00D = "^HDPO00+^HDVO00+^HDPOA0";

		SUMPNDS = "^HTPONDS+^HDPONDS+^HTVONDS+^HDVONDS"
		SUMPNDST = "^HTPONDS+^HTVONDS+round(^HTPOSNDS/6+^HTVOSNDS/6,2)";
		SUMPNDSD = "^HDPONDS+^HDVONDS+round(^HDPOSNDS/6+^HDVOSNDS/6,2)";
	}
	else
	{
		SUM20 = "^HDP20+^HTP20+^HDV20+^HTV20";
		SUM20D = "^HDP20+^HDV20";
		SUM20T = "^HTP20+^HTV20";

		SUM00 = "^HDPIMT+^HTPIMT+^HDVIMT+^HTVIMT";
		SUM00D = "^HDPIMT+^HDVIMT+^HDP00N+^HDV00N";
		SUM00T = "^HTPIMT+^HTVIMT+^HTP00N+^HTV00N";

		SUMPNDS = "^HTPNDS+^HDPNDS+^HTVNDS+^HDVNDS";
		SUMPNDST = "^HTPNDS+^HTVNDS";
		SUMPNDSD = "^HDPNDS+^HDVNDS";

	}

	SUMXX = sType=="-"?"HDPOXX+HTPOXX+HTSOXX+HDVOXX+HTVOXX"
					  :"HDP00N+HTP00N+HDV00N+HTV00N";
	SUMA0 = sType=="-"?"HDPOA0+HTPOA0+HTSOA0+HDVOA0+HTVOA0"
					  :"HDPIMV+HTPIMV+HDVIMV+HTVIMV";
	SUMB0 = sType=="-"?"HDPOB0+HTPOB0+HTSOB0+HDVOB0+HTVOB0"
					  :"HDPN00+HTPN00+HDVN00+HTVN00";
	SUME0 = sType=="-"?"HDPOE0+HTPOE0+HTSOE0+HDVOE0+HTVOE0"
					  :"HDP000+HTP000+HDV000+HTV000";
	SUMPNIM20 = sType=="-"
					?"HTPOA0+HDPOA0+HTPO00+HDPO00+HTVOA0+HDVOA0+HTVO00+HDVO00"
						:"HTPIMV+HDPIMV+HTPIMTN+HDPIMTN+HTPIMVN+HDPIMVN+HTPIMNR"
					 	+"+HDPIMNR+HTPIMT+HDPIMT+HTVIMV+HDVIMV+HTVIMTN+HDVIMTN"
					 	+"+HTVIMVN+HDVIMVN+HTVIMNR+HDVIMNR+HTVIMT+HDVIMT"
	SUMPNND = sType=="-"?"0"
						:"HTPNDSOS+HDPNDSOS+HTPNDSNV+HDPNDSNV+HTVNDSOS"
						+"+HDVNDSOS+HTVNDSNV+HDVNDSNV";
	SUMPNIMND = sType=="-"?"0"
						  :"HTPNDSN+HDPNDSN+HTPNDSNR+HDPNDSNR"
						  +"+HTVNDSN+HDVNDSN+HTVNDSNR+HDVNDSNR";
	SUMPN00 = sType=="-"?"HTPOE0+HDPOE0+HTPOXX+HDPOXX+HTVOE0+HDVOE0+HTVOXX+HDVOXX"
                		:"HTP000+HDP000+HTP00N+HDP00N+HTV000+HDV000+HTV00N+HDV00N";
	SUMPNIM00 = sType=="-"?"0":"HTPIMBN+HDPIMBN+HTPNV+HDPNV+HTVIMBN+HDVIMBN+HTVNV+HDVNV";
	SUMU = sType=="-"?"HSDPU+HSTPU+HSDVU+HSTVU":"0";
	SUMND = sType=="-"?"HTPONDS+HTSONDS+HTVONDS+HDPONDS+HDVONDS"
					 :"HTPNDS+HTVNDS+HDPNDS+HDVNDS";
	SUMNA = sType=="-"?"0":"HDPIMNV+HTPIMNV";

	SUM_ALL = SUM20 + "+" + SUM00 + "+" + SUMA0 + "+" + SUMB0
	 	     	    + "+" + SUMND + "+" + SUMNA + "+" + SUMPNND
  			  		+ "+" + SUMPN00 + "+" + SUMPNIMND;

	SUM_ALL_T = SUM20T + "+" + SUM00T //+ "+" + SUMPNDST;
	SUM_ALL_D = SUM20D + "+" + SUM00D //+ "+" + SUMPNDSD;
}

function listLoad()
{
//-	DpList_ProtTable	= "DOCREG";
//-	DataSource().addAccel(GA_CTRL, "P", "FINDPROV");
//-	DataSource().addAccel(GA_CTRL, "D", "FIND_DOC");

	this.printLabel = "regekz";
/*      subDpGrid = initGrid;
      subSrc = infSrc;
      subAsk = askParam;
      subOnPrnList = onPrnList;
      subMenuInit = menuInit;
      subMenuRun = menuRun;
*/
	if (extPar)
	{
		if(extPar.fid_doc)
			m_Id_doc = extPar.fid_doc;
	    if(extPar.freg)
			m_Reg = extPar.freg;
		if(extPar.fvid)
			m_Vid = extPar.fvid;
	}
	else if (GetMenuMode())
	{
		m_Reg = GetMenuMode();
		if (inList(m_Reg, "PLUS", "MINUS"))
		{
			if (m_Reg == "PLUS")
				m_Vid = "+";		
			else
				m_Vid = "-";	
			m_Reg = 0;				
		}		
	}
	else
		return false;

	if (!m_Vid)
	{
		var jrnl = new DpJournal("S",m_Reg);
		m_Vid = strIn("P",jrnl.getType())?"+":"-";
	}
	
	sDocregTbl = getPath("ALL_MDB") + "." + (SUBD==MSSQL?".":"") + (m_Vid=="+"?"P":"M") + "DOCREG";
	initSumFields(m_Vid);
	
	this.showProvDocView = showProvDocView;
	this.showProvRegView = showProvRegView;
	grid.addAccel(GA_CTRL, "D", "FIND_DOC");
}

function showProvDocView()
{
	
	var par = new Object()
	par.fdoc = this.tbl.getValue("HDOC")
	par.fnop = this.tbl.getValue("HNOP")
	par.fid_doc = Number(this.tbl.getValue("hid_doc"));
	var view = lpProxy.getView("provfordoc");
	if (view == null)
	{
		
		this.selRecordHandler = selRecordHandler;
		grid.setSelHandler(this, "selRecordHandler"); 
		lpProxy.showView("provfordoc", "l_prov.js", par)
	}
	else
	{
		view.sendMessage("prov", par);	
	}
}

function showProvRegView()
{
	
	var par = new Object()
	par.fdoc = "_R";
	//par.fnop = this.m_Nop;
	par.fid_doc = Number(this.tbl.getValue("hid_doc"));
	var view = lpProxy.getView("provforreg");
	if (view == null)
	{
		
		this.selRecordHandler = selRecordHandler;
		grid.setSelHandler(this, "selRecordHandler"); 
		lpProxy.showView("provforreg", "l_prov.js", par)
	}
	else
	{
		view.sendMessage("prov", par);	
	}
}

function selRecordHandler()
{
	if (this.tm == null)
	{
		this.tm = runTimer(runViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
	
	//runViews();
}

function runViews()
{
	var par = new Object()
	
	var view = lpProxy.getView("provfordoc");
	if (view != null)
	{
		par.fdoc = list.tbl.getValue("hdoc");
		par.fnop = list.tbl.getValue("hnop");
		par.fid_doc = Number(list.tbl.getValue("hid_doc"));	
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("prov", par);	
		}
	}
	
	var view = lpProxy.getView("provforreg");
	if (view != null)
	{
		par.fdoc = "_R";
		//par.fnop = list.tbl.getValue("hnop");
		par.fid_doc = Number(list.tbl.getValue("hid_doc"));	
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("prov", par);
		}
	}

	grid.setFocus();
}

function listTitle()
{
	return UR("Список зареєстрованих документів|Список зарегистрированых документов");
}

function listAsk()
{
	if(!m_Id_doc)
		return new DpGetDat(new Array("r2", "o0"));
	return new Object();
}

function listSrc()
{
   	var w = SqlCmpTrue;
  	if( m_Reg )
     	w = w + " AND HREG=" + sqlTo(m_Reg);
  	if( m_Doc )
     	w = w + " AND HDOC=" + sqlTo(m_Doc);
  	if( m_Nop )
     	w = w + " AND HNOP=" + sqlTo(m_Nop);
  	if( m_Id_doc )
     	w = w + " AND HID_DOC=" + sqlTo(m_Id_doc);
  	if( m_Id_contr )
     	w = w + " AND HIDCONTR=" + sqlTo(m_Id_contr);
  	if(this.objAsk.dat1 && this.objAsk.dat2 )
    	 w = w + " AND ("
	       + "(HDAT BETWEEN " + sqlTo(this.objAsk.dat1)
           + " AND " + sqlTo(this.objAsk.dat2)
           + ") OR (HNKDAT BETWEEN " + sqlTo(this.objAsk.dat1)
           + " AND " + sqlTo(this.objAsk.dat2)
   		   + "))";

  	if(this.objAsk.forg)
		w += " AND HORG=" + sqlTo(this.objAsk.forg);

	this.qrySet(
		"From", sDocregTbl
		, "WhereArr", new Array(w
			, w + " AND horg IN (SELECT horg FROM " + sDocregTbl + " WHERE " + w + " GROUP BY horg HAVING min(hiddeal)<>max(hiddeal))"
			)
		, "WhereArrName", new Array("Полный список", "Отобрать организации с более чем 1 связкой")
		, "WhereArrI", 0
		//, "Order", "Horg,HGROUP,Hiddeal,Hdat desc,Hisnov1 desc"
		//, "Order", "Horg,Hiddeal,Hdat"
		, "Order", new Array("Horg,Hiddeal,Hdat","hgroup,hiddeal,hdat,horg,hisnov1 desc")
		, "OrderName", new Array("Сортировать по организации", "Сортировать по договору")
		, "Ptn", "DOCREG"
	        );
	this.noExpandAll = true;	        

	this.subTie("CLRELCLCL", "REL", "CLCOD", "="+sprOrg+",Horg",null,TIE_NOSEARCH);
	this.subTie("CL", "x_cl", "FWID", "REL.FWID_CL",null,TIE_NOSEARCH);
	this.subTie("CL_LNK", "x_cl_lnk", "CL_LNK", "Hdoc,Hnop",null,TIE_NOSEARCH);
	this.subTie("CONTRACT", "x_contract", "FWID", "Hidcontr",null,TIE_NOSEARCH);
	
	this.extTieEx("ORG", "REL.FWID_CL", "CL", String(sprOrg), null);
	this.extTieEx("ORG0", "REL.FWID_CL", "CL", "0", null);
	//this.extTieEx("ext0","REL.FWID_CL","CL","0");
}

function listDpGridEx(oGrid)
{
	with(oGrid)
	{
		oGrid.defCond("=^hsch && !grid_isprov()", "hsch")
		oGrid.defCond("=grid_isprov()", "isprov");
		oGrid.defCond("=!^hiddeal", "deal");

		oGrid.color(1, "isprov");
		oGrid.color(3, "hsch");
		oGrid.color(2, "deal")
		
		oGrid.objGrid.setFilling("HORG|HIDDEAL");                                    
		//oGrid.objGrid.setFilling(new Array("=^HORG", "=^HIDDEAL"));
		
		/*
		switch(getPar("PR_DOGREG"))
		{
		case "-":
			
			oGrid.objGrid.setFilling("HORG|HIDDEAL");
			break;
		case "*":
			oGrid.objGrid.setFilling("HORG|HIDDEAL|HGROUP");
			break;
		case "+":
			oGrid.objGrid.setFilling("HORG|HIDDEAL|HIDCONTR");
			break;
		}
		*/ 

		oGrid.objGrid.setViewerID("l_regekz.js.grid." + (m_Vid=="+"?"P":"M"));
//-		addObject(new DocSums, "j");
		with(page())
		{
			with (group("Контрагент|Контрагент"))
			{
				cell("Horg","Код|Код",7);
				cell("x_cl.Ftxt","Контрагент|Контрагент",20);
			}
			//FieldEx("x_cl_lnk.Ftxts","Вид док.|Вид док.",7);
			with (group("Документ"))
			{
				cell("Hdoc","Док.|Док.",5);
				cell("Hnop","Опер.|Опер.",4);
				cell("Hnom","№",5);
			}
			cell("Hdat","Дата|Дата",8);
			with (group("Оплата"))
			{
				cell("=" + SUM_ALL_D, "Без ПДВ|Без НДС", 14, "zn", DP_FORMAT_SUM);
				cell("=" + SUMPNDSD, "ПДВ|НДС", 14, "zn", DP_FORMAT_SUM);
				cell("=" + SUM_ALL_D + "+" + SUMPNDSD, "З ПДВ|С НДС", 14, "zn", DP_FORMAT_SUM);
			}
			with (group("Відвантаження|Отгрузка"))
			{
				cell("=" + SUM_ALL_T, "Без ПДВ|Без НДС", 14, "zn", DP_FORMAT_SUM);
				cell("=" + SUMPNDST, "ПДВ", 14, "zn", DP_FORMAT_SUM);
				cell("=" + SUM_ALL_T + "+" + SUMPNDST, "З ПДВ|С НДС", 14, "zn", DP_FORMAT_SUM);
			}
			if (m_Vid == "+")			
			{
				cell("=" + SUM_ALL_D + "+" + SUMPNDSD + "+" + SUM_ALL_T + "+" + SUMPNDST
						,"Сума з ПДВ|Сумма с НДС",15, "zn", DP_FORMAT_SUM);
			}
			else
				cell("","Сума з ПДВ|Сумма с НДС",15, "zn", DP_FORMAT_SUM);
			cell("Hreg", "Журнал", 9)
		}
		with(page())
		{
			cell("x_cl_lnk.Ftxts","Вид док.|Вид док.",9);
			cell("=!^Hisnov1", "Видана|Выдана", 7)
			cell("Hnknom","№ под.накл.|№ нал.накл.",12);
			cell("Hnkdat","Дата под.накл.|Дата нал.накл.",14);
			cell("HVID_DOC","Тип накл.|Тип накл.",12);
			cell("Hopform","Форма спл|Форма опл",12);
			cell("Hprcond","Умова прод|Усл. прод",12);
			cell("Hgroup", "Група|Группа", 9);
			cell("=nomDogByID(^HIDCONTR)", "Угода|Договор", 9);
			cell("HV", "Вал.", 6);
			cell("HVKURS", "Курс.", 6);			
		}
		if (m_Vid=="+" || m_Vid=="-")
		{
			var num_mng = getRegPar(m_Vid,"CODMNG")
			var num_zone = getRegPar(m_Vid,"CODZONE")
			with(page())
			{
				switch (m_Vid)
				{
				case "-":
					cell("SUM20","Сума  (20% ПДВ)|Сумма (20% НДС)",14, DP_FORMAT_SUM);
					cell("SUMND","Сума ПДВ|Сумма НДС",14, DP_FORMAT_SUM);
					cell("SUM0NDS","Сума ( 0% ПДВ)|Сумма ( 0% НДС)",14, DP_FORMAT_SUM);

					cell("=(^Hdoc == 'PP' ? ^SUMALL : 0)","Оплата",14, DP_FORMAT_SUM);
					cell("=(^Hdoc == 'PP' ? ^SUMND : 0)","НДС по оплате",14, DP_FORMAT_SUM);
					cell("=(^Hdoc != 'PP' ? ^SUMALL : 0)","Отпуск",14, DP_FORMAT_SUM);
					cell("=(^Hdoc != 'PP' ? ^SUMND : 0)","НДС по отпуску",14, DP_FORMAT_SUM);
					cell("=(^Hdoc == 'PP' ? ^SUMALL : 0) - (^Hdoc != 'PP' ? ^SUMALL : 0)","Разница",14, DP_FORMAT_SUM);
					break;
				case "+":
					cell("SUM20NDS","Сума  (20% ПДВ)|Сумма (20% НДС)",14, DP_FORMAT_SUM);
					cell("SUMNDS","Сума ПДВ|Сумма НДС",14, DP_FORMAT_SUM);
					cell("SUM0NDSP","Сума ( 0% ПДВ)|Сумма ( 0% НДС)",14, DP_FORMAT_SUM);

					cell("=(^Hdoc == 'PP' ? ^SUMALL : 0)","Оплата",14, DP_FORMAT_SUM);
					cell("=(^Hdoc == 'PP' ? ^SUMNDS : 0)","НДС по оплате",14, DP_FORMAT_SUM);
					cell("=(^Hdoc != 'PP' ? ^SUMALL : 0)","Отпуск",14, DP_FORMAT_SUM);
					cell("=(^Hdoc != 'PP' ? ^SUMNDS : 0)","НДС по отпуску",14, DP_FORMAT_SUM);
					cell("=(^Hdoc == 'PP' ? ^SUMALL : 0) - (^Hdoc != 'PP' ? ^SUMALL : 0)","Разница",14, DP_FORMAT_SUM);
					break;
				}
			}
			with(page())
			{
				if (getRegPar(m_Vid,"CODZONE") != 0)
					cell("=tcl('CL','TXT',"+num_zone+", ^hzone)","Зона|Зона",15);
				if (getRegPar(m_Vid,"CODMNG") != 0)
					cell("=tcl('CL','TXT',"+num_mng+", ^Hmeneger)","Менеджер|Менеджер",15);
				cell("Hgroup","N угоди|N договора",11);
				cell("Hdtots","Дата под.накл.|Дата нал.накл.",14);
				cell("Hdt_otse","Дата к.п|Дата к.п",12);
			}
			with(page())
			{
				cell("Hsc", "Рах.|Счёт", 6);
				cell("Hsu", "C/рах.|С/счёт", 6);
				cell("Hst", "Стаття|Статья", 7);
			}
		}
	}
	
	return;
}

function listBeforeGridBuild()
{
	grid.addExtPage("ORG");
	grid.addExtPage("ORG0");
}

function listMenuInit(toObject)
{ 
   	with(toObject)
   	{
	  	if(this.tbl.isRecord())
  		{
		 	//if (askKey(1))
			//	AddMenuItem("SORT_DOC","Перегрупувати документи|Перегруппировать документы");
	     	AddMenuItem("FIND_DOC","Пошук документа|Поиск документа");
	     	AddMenuItem("EDIT","Редагування документа|Редактирование документа");
	      	AddMenuItem("PRINT1","Друк документа|Печать документа");
		 	AddMenuItem("FINDPROV","Показати проведення по докум.|Показать проводки к докум.");
		  	AddMenuItem("FINDRPROV","Показати проведення по реєстрацiї|Показать проводки к регистрации");
	     	AddMenuItem("","");
	     	AddMenuItem("EXEDOCOP","Формування проведень|Формирование проводок");
	     	AddMenuItem("DELDOCOP","Видалення проведень|Удаление проводок");
	     	AddMenuItem("","");
	
	     	if ((list.par["FIDCONTR"]==null || list.par["FIDCONTR"].trim()==id00.trim()) && !m_Id_contr)
	     	{
	        	AddMenuItem("INREG","Зв'язати в реєстрацію|Связать в регистрацию");
	        	AddMenuItem("OUTREG","Виключити з реєстрації|Исключить из регистрации");
	      	}  
	      	//else
	        //  	AddMenuItem("VK_INDOG","Додати до угоди|Включить в договор");
	      	// AddMenuItem("OUT_OFDOG","Виключити з угоди|Исключить из договора");
	      	
	      	    
	      	if ((list.par["FIDCONTR"]==null || list.par["FIDCONTR"].trim()==id00.trim()) && !m_Id_contr)
	      	{    
	      		// Зачем здесь перевод в другую папку ??? 
	      		// Пусть находит документ и переводит его обычным методом
	        	//AddMenuItem("DOCMOVE","Переведення документів|Перевод документов");
	      	}  
	
	      	if(true || m_Reg )
	      	{
	      		AddMenuItem("","");
	      		switch( m_Vid )
	         	{
	         	case "-":
	         		
					AddMenuItem("+++", "Реєстр виданих податкових накладних|Реестр выданных налоговых накладных");
					AddMenuItem("RNALV","Розрахунок|Расчет");
					AddMenuItem("RNALVVIEW", "Перегляд|Просмотр");
					AddMenuItem("---", "");
					AddMenuItem("CHECKLINK", "Поиск организаций с не связанными документами");

					/*
					AddMenuItem("+++", "Книга обліку продажів|Книга учета продаж");
					AddMenuItem("REGBOT","Розрахунок|Расчет");
					AddMenuItem("REGBOTVIEW", "Перегляд|Просмотр");
					AddMenuItem("---", "");
					*/
					
					// Неизвестно, что делает
					// AddMenuItem("NO_PAY_DOC", "Неоплаченнi документи |Неоплаченные документы")
					
					break; 
					
	         	case "+":
	         		// 
					//AddMenuItem("NN", "Перевести в NN");
	         		
					AddMenuItem("+++", "Реєстр отриманих податкових накладних|Реестр полученных налоговых накладных");
					AddMenuItem("RNALP","Розрахунок|Расчет");
					AddMenuItem("RNALPVIEW", "Перегляд|Просмотр");
					AddMenuItem("---", "");
	
					/*
					AddMenuItem("+++", "Книга обліку покупок|Книга учета покупок");
					AddMenuItem("REGBPN","Розрахунок|Расчет");
					AddMenuItem("REGBPN1", "Розрахунок (18 кол.з ПДВ)|Расчет (18 кол.с НДС)");
					AddMenuItem("REGBPNVIEW", "Перегляд|Просмотр");
					AddMenuItem("---", "");
					*/
	            	break;
	         	}
	
	      		//AddMenuItem("KONTR","Зв'язати в реєстрацію по контрагенту|Связать в регистрацию по контрагенту");
	      		AddMenuItem("ACTCMP","Акт звірення|Акт сверки");
	
	      	}
	
	      	// AddMenuItem("NKTAX","Реєстр податкових накладних|Реестр налоговых накладных");
	      	
	//      	if (m_Vid=='+' || m_Vid=='-')
	//        	AddMenuItem("PRSUM","Перевiрка сум ПДВ|Проверка сумм НДС");
	   }
		AddMenuItem("", "");
		AddMenuItem("REREG", "Перерегистрировать все")
		var selCnt = getSelectedCount();
		if(selCnt>0)
		{
			AddMenuItem("+++", "Сервiс|Сервис");
			AddMenuItem("SETNEWVIDP", "Проставити новий тип паперової накладної для відмічених ("+ selCnt +")|Проставить новый тип печатной накладной для отмеченных ("+ selCnt +")");
			AddMenuItem("SETNEWVIDE", "Проставити новий тип електронної накладної для відмічених ("+ selCnt +")|Проставить новый тип электронной накладной для отмеченных ("+ selCnt +")");
			AddMenuItem("---", "Сервiс|Сервис");
		}
  	}
}

function listMenuRun(ID)
{
	list.objParMenu.fvid = m_Vid;
	list.objParMenu.freg = m_Reg;
	list.objParMenu.tblName = sDocregTbl; 		
	
	switch(String(ID))
	{
		case "RNALV":
   		case "RNALVVIEW":
			var oPar = new Object();
			oPar.freg = m_Reg;
			oPar.fvid = m_Vid;
			if(ID == "RNALVVIEW")
				oPar.menuMode = "VIEW";
			showWindow("r_rnalv.js",SW_NOMODAL,oPar,"");
		    break;
	    case "RNALP":
	    case "RNALPVIEW":
	    	var oPar = new Object();
	    	oPar.freg = m_Reg;
	    	oPar.fvid = m_Vid;
	    	if(ID == "RNALPVIEW")
				oPar.menuMode = "VIEW";
	    	showWindow("r_rnalp.js",SW_NOMODAL,oPar,"");
		    break
	
		case "SORT_DOC":	//Перегруппировать документы
			tbl_sort = OpenTable("s","SELECT * FROM "+ sDocregTbl +" WHERE "+ list.dataSrc.sqlSelected());
			if (tbl_sort.recordCount() != 2)
			{
				alert(ru("Операция не выполнена. Выделите только две позиции","Операція не виконана. Виділіть лише дві позиції"));
				break;
			}			
			var sort1 = tbl_sort.getValue("Hsort");
			var id1 = tbl_sort.getValue("fwid");
			tbl_sort.MoveNext();
			var sort2 = tbl_sort.getValue("Hsort");
			var id2 = tbl_sort.getValue("fwid");			
			var fsort = IIF("Fwid="+id1, sort2, sort1);
			ExecuteSQL("UPDATE "+ sDocregTbl +" SET Hsort="+ fsort +" WHERE "+ list.dataSrc.sqlSelected());			
			break;
		
		case "EXEDOCOP":	//Формирование проводок
			include("doc/DpExeDoc.js");
			var exeD = new DpExeDocOp();
			var sSQL = "select * FROM " + sDocregTbl + " WHERE " + list.dataSrc.sqlSelected()
			var t = OpenTable("s", sSQL);
			var bMass = t.recordCount > 1;
			//ускорили массовое формирование проводок перенеся цикл в exeRegOp
			var bRet = exeD.exeRegOp(t, false, bMass);
			t.close();
			if (!(bRet === false))
			{
				sSql = "UPDATE "+ sDocregTbl +""
					+ " SET hsch = "+SqlTrue
					+ " WHERE " + list.dataSrc.sqlSelected();
				ExecuteSQL(sSql)	
			}
			list.tbl.requery();			
			grid.RefreshGrid(true);
					
			break;
   		case "DELDOCOP":	//Удаление проводок
			include("objects/DpMsgBox.js");
			var msg = new DpMsgBox();
			msg.set("-c", ru("Вы действительно желаете удалить проводки?","Ви дійсно бажаєте видалити проведення?"),"")
			if(msg.ask()=="-")
			{
				var sSQL = "select * FROM " + sDocregTbl + " WHERE " + list.dataSrc.sqlSelected()
				var t = OpenTable("s", sSQL);
				while (!t.isEOF())
				{
					ExecuteSQL("delete FROM ^schet where fdoc= '_R' and fid_doc=" + t.getValue("hid_doc"));
					t.MoveNext();
				}
				t.close();
								
				sSql = "UPDATE "+ sDocregTbl + " SET hsch = "+SqlFalse
					+ " WHERE " + list.dataSrc.sqlSelected();
				ExecuteSQL(sSql);	
				list.tbl.requery();			
				grid.RefreshGrid(true);
			}
			break;
			
   		case "FIND_DOC":	//Поиск документа
     	 	include("doc/DpDocPtn.js");
     	 	FindDocument(list.tbl.getValue("Hdoc")
     	 			,list.tbl.getValue("Hnop")
     	 			,list.tbl.getValue("Hid_doc"));	//docinfo("HFILE", list.tbl.getValue("Fdoc"))=="^DOCREG"?"FWID":"Fid_doc"
      		return;
      		
   		case "FINDPROV":	//Поиск проводок к докум.
      		//include("doc/DpDocPtn.js");
      		//FindProv(list.tbl,"Hid_doc");
      		this.showProvDocView();
      		return;
      		
   		case "FINDRPROV":	//Поиск проводок к регистрации
      		//include("doc/DpDocPtn.js");
      		//FindProv(list.tbl, "Fwid");
      		this.showProvRegView();
      		return;
   		
   		case "INREG":		//Связать в регистрацию
      		var dopzm1 = GetUID();
      		strSQL = "UPDATE "+ sDocregTbl +" SET HIDDEAL="+ dopzm1 
      				+" WHERE "+ list.dataSrc.sqlSelected();
      		ExecuteSQL(strSQL);
      		var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);
      		break;
   		
		case "CHECKLINK":
			var d = new DpGetDat(new Array("r"));
			browse("select horg KodOrg"
					//+ ", (select (org.ftxt) from ^listclorg org where org.fcod=horg)"
					+ ", count(distinct hiddeal) hcnt"
				+ " from ^mdocreg"
				+ " where hreg=" + sqlTo(m_Reg)
					+ " and hdat between " + sqlTo(d.dat1) 
					+ " and " + sqlTo(d.dat2) 
				+ " group by horg"
				+ " having count(distinct hiddeal)>1 order by horg"
				)
		
		break;      		
      		
   		case "OUTREG":		//Исключить из регистрации
	  		strSQL = "UPDATE "+ sDocregTbl +" SET HIDDEAL= null "
					+" WHERE "+ list.dataSrc.sqlSelected();
	  		ExecuteSQL(strSQL);
	  		var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);
      		break;
      		
   		case "SV_INDOG":	//Связать в договор
      		var  d_Fwid, d_Fdog_num, d_Ftxt, d_Forg, d_Fbdat, d_Fedat;
      		d_Fbdat = d_Fedat = d00;
      
      		var doptab = new Object();
      		doptab = getSnap("SELECT FWID, HORG FROM "+ sDocregTbl 
      				+" WHERE "+ list.dataSrc.sqlSelected() 
      				+" ORDER BY HORG");
      		if (doptab!=null)
      		{         		
         		d_Forg = doptab[1];         		      		
      		}
      		list.objParMenu.escape = true;
      		showWindow("sv_cntrct.xml", SW_MODAL, list.objParMenu, "");
      
      		if (list.objParMenu.escape==true)
        		break;
       
      		d_Ftxt = list.objParMenu.ftxt;
      		d_Fbdat = list.objParMenu.fbdat;
      		d_Fedat = list.objParMenu.fedat;
      		d_Fdog_num = list.objParMenu.fdog_num;
      		d_Fwid = GetUID();
      
      		strSQL = "UPDATE "+ sDocregTbl 
      				+" SET HIDCONTR="+ sqlTo(d_Fwid)
      				+" WHERE "+ list.dataSrc.sqlSelected();
      		ExecuteSQL(strSQL);
        
			strSQL = "INSERT INTO ^CONTRACT (Fdog_num,Fwid,Ftxt,Fbdat,Fedat,Forg) "
				+" VALUES ("+ sqlTo(d_Fdog_num) + "," + sqlTo(d_Fwid) 
					+ "," + sqlTo(d_Ftxt) + "," +sqlTo(d_Fbdat) 
					+ "," + sqlTo(d_Fedat) + "," + sqlTo(d_Forg) + ")";
			ExecuteSQL(strSQL);    
			var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);;
     	 	break;
     	 	
   		case "VK_INDOG":	//Включить в договор
      		strSQL = "UPDATE "+ sDocregTbl 
      				+" SET HIDCONTR="+sqlTo(list.par["HIDCONTR"])
      				+" WHERE "+list.dataSrc.sqlSelected();
      		ExecuteSQL(strSQL);
      		var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);
      		break;
      		
   		case "OUT_OFDOG":	//Исключить из договора
     		var __fwid = findFwidForXDel();
     		strSQL = "UPDATE "+ sDocregTbl +" SET HIDCONTR=0"
     				+" WHERE "+list.dataSrc.sqlSelected();
      		ExecuteSQL(strSQL);
      		var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);
      		return DpList_exit;
      		
   		case "KONTR":		//Связать в регистрацию по контрагенту
      		linkGroup();
      		var id = list.tbl.getValue("FWID"); 
      		list.tbl.requery();
      		list.tbl.findByID(id);
			grid.RefreshGrid(true);
      		break;      		
   		      		
   		case "REGBOT":		//Книга учета продаж
   		case "REGBOTVIEW":
      		list.objParMenu.menuMode = strIn("VIEW", ID)? "VIEW": "CALC";
      		showWindow("r_regbot.js", SW_NOMODAL, list.objParMenu, "");
      		break;
      		
   		case "REGBPN1":		//Книга учета покупок
      		list.objParMenu.vid = "18NDS"
   		case "REGBPN":
   		case "REGBPNVIEW":
      		list.objParMenu.menuMode = strIn("VIEW", ID)? "VIEW": "CALC";
      		showWindow("r_regbpn.js",SW_NOMODAL,list.objParMenu,"");
      		break;
      		
   		case "NKTAX":		//Реестр налоговых накладных
      		list.objParMenu.menuMode = "CALC";
      		showWindow("r_nktax.js",SW_NOMODAL,list.objParMenu,"");
      		break;
      		
   		case "ACTCMP":		//Акт сверки
      		list.objParMenu.menuMode = "CALC";       		
  			if(this.objAsk != null && this.objAsk.forg)
				list.objParMenu.forg = this.objAsk.forg;
      		showWindow("r_actcmp.js",SW_NOMODAL,list.objParMenu,"");
      		break;
      		
   		case "NO_PAY_DOC":	//Неоплаченные документы
     		showWindow("r_ddeal.js",SW_NOMODAL,list.objParMenu,"");
      		break;
      		
   		case "PRSUM":         
      		break; 
      		 
   		case "DOCMOVE":		//Перевод документов
      		/*var newFwid = "";
      		var fromDoc = list.tbl.getValue("Hdoc");
      		var fromNop = list.tbl.getValue("Hnop");
      		var FileName = docinfo("HFILE",fromDoc);
      		var t1 = OpenTable("s", "SELECT * FROM " + FileName 
      				+" WHERE FWID = " + sqlTo(list.tbl.getValue("HID_DOC")));
      		var whereDoc, whereNop;
      		var _fwid = FindFwidForDelete(list.tbl);
      		// Выбор папки, куда переводить
      		var par = Object();
      		par.escape = true;
      		if (!t1.IsEOF())
      		{
         		par.Fdoc = fromDoc;
         		showWindow("l_docmov.js", SW_MODAL, par);
      		}
      		if(par.escape)
      			return;

      		whereDoc = par.Fdoc;
      		whereNop = par.Fnop;
      		var objDoc = new dpDoc(t1,null,t1.getValue("FDOC")
      				,t1.getValue("FNOP"),t1.getValue("FWID"));
      		if ((findok = objDoc.msgMoveOk(whereDoc, whereNop)))
      		{
           		objDoc.move(whereDoc, whereNop);
           		moveExt(fromDoc, fromNop, whereDoc, whereNop);
      		}
       		objDoc = null;
	
      		list.tbl.Requery();
      		RestoreMarker(list.tbl);
     		return DpList_exit;
     		*/
     		var oPar = new Object();			
			oPar.ret = new Object();
			oPar.doc = list.tbl.getValue("Hdoc")
			oPar.ret.fdoc = oPar.doc;
			oPar.ret.fnop = list.tbl.getValue("Hnop");
			var horg = list.tbl.getValue("HORG");			
			
			showWindow("l_docmove.js",SW_MODAL,oPar);
			if (oPar.escape) 
				return;
			
			var sDoc = oPar.ret.fdoc;
			var nNop = oPar.ret.fnop;
			var arrIds = grid.getSelectedIDs();
		
			var delProv = false;
			var doMove = true;
			for (var i = 0; i < arrIds.length; i++)
			{
				var oDoc = new DpDoc(sDoc, nNop);
			
				if (!oDoc.loadByID(arrIds[i], true))
					continue;
					
				var provCount = 0;
				var oSnap = getSnap("SELECT COUNT(*) FROM ^schet"
						  	+ " WHERE FID_DOC=" + sqlTo(arrIds[i])
							);
				if (oSnap != null)
					provCount = oSnap[0];
				
				if (provCount != 0)
				{
					var confrm = msgBox("cyn"
								,UR("Документ має проведення.\nВидалити проведення?"
									+ "|Документ имеет проводки.\nУдалить проводки?")
								,UR("Видалення проводок | Удаление проводок")
								);
					delProv = (confrm == "y");
					doMove =  (confrm != "c");
				}
				if (!doMove)
				{
					return false;
				}
			
				if (delProv)
				{	
					ExecuteSQL("DELETE FROM ^SCHET WHERE FID_DOC=" + sqlTo(arrIds[i]));
				}				
				
				oDoc.delRegistration();	
				oDoc.setVar("HOP", nNop);
				oDoc.serverSave();
			}
			if (i == 0)
			{
				var oDoc = new DpDoc(sDoc, nNop);
			
				if (!oDoc.loadByID(this.tbl.getValue("HID_DOC")))
					return;
				
				var provCount = 0;
				var oSnap = getSnap("SELECT COUNT(*) FROM ^schet"
						  + " WHERE FID_DOC=" + sqlTo(this.tbl.getValue("FWID"))
							);
				if (oSnap != null)
					provCount = oSnap[0];
				
				if (provCount != 0)
				{
					var confrm = msgBox("cyn"
								,UR("Документ має проведення.\nВидалити проведення?"
									+ "|Документ имеет проводки.\nУдалить проводки?")
								,UR("Видалення проводок | Удаление проводок")
								);
					delProv = (confrm == "y");
					doMove =  (confrm != "c");
				}
				if (!doMove)
				{					
					return false;
				}
			
				if (delProv)
				{	
					ExecuteSQL("DELETE FROM ^SCHET "
						+" WHERE FID_DOC=" + sqlTo(this.tbl.getValue("HID_DOC")) + " AND FDOC = '_R' ");
				}
				
				oDoc.delRegistration();	
				oDoc.setVar("HOP", nNop);
				oDoc.serverSave();
			}
			ExecuteSQL("UPDATE "+ sDocregTbl +" SET HORG="+ horg 
					+" WHERE HID_DOC="+ oDoc.getID());		
			list.tbl.requery();	
			grid.refresh();
			return;
		
   		case "EDIT":
     		var oPar     = new Object();
     		oPar.mode    = "EDIT";
     		oPar.Fdoc    = list.tbl.getValue("HDOC");
     		oPar.Fnop    = list.tbl.getValue("HNOP");
     		oPar.Freg    = list.tbl.getValue("HREG");
     		/*
     		var editTask;     		
     		if (inList(oPar.Fdoc, "OT", "NK", "SF", "VZ", "VR", "PU", "SM"
     							, "PZ", "VP", "VM", "PM", "TZ", "PN", "OC"))
     		{
         		oPar.isReg  = false;
         		oPar.Fwid   = list.tbl.getValue("HID_DOC");
     		}
     		else if (oPar.Fdoc == "SR")
     		{
      			oPar.Fwid   = list.tbl.getValue("FWID");
     		}
     		else
     		{
         		var SUM20   = Number(list.tbl.getValue("HSDPO_20"))
         					+ Number(list.tbl.getValue("HSTPO_20"))
         					+ Number(list.tbl.getValue("HSTSO_20"))
         					+ Number(list.tbl.getValue("HSDVO_20"))
         					+ Number(list.tbl.getValue("HSTVO_20"));
		        var SUM00   = Number(list.tbl.getValue("HSDPO_00"))
		        			+ Number(list.tbl.getValue("HSTPO_00"))
		        			+ Number(list.tbl.getValue("HSTSO_00"))
		        			+ Number(list.tbl.getValue("HSDVO_00"))
		        			+ Number(list.tbl.getValue("HSTVO_00"));
		        var SUMXX   = Number(list.tbl.getValue("HSDPO_XX"))
		        			+ Number(list.tbl.getValue("HSTPO_XX"))
		        			+ Number(list.tbl.getValue("HSTSO_XX"))
		        			+ Number(list.tbl.getValue("HSDVO_XX"))
		        			+ Number(list.tbl.getValue("HSTVO_XX"));
		        var SUMA0   = Number(list.tbl.getValue("HSDPO_A0"))
		        			+ Number(list.tbl.getValue("HSTPO_A0"))
		        			+ Number(list.tbl.getValue("HSTSO_A0"))
		        			+ Number(list.tbl.getValue("HSDVO_A0"))
		        			+ Number(list.tbl.getValue("HSTVO_A0"));
		        var SUMB0   = Number(list.tbl.getValue("HSDPO_B0"))
		        			+ Number(list.tbl.getValue("HSTPO_B0"))
		        			+ Number(list.tbl.getValue("HSTSO_B0"))
		        			+ Number(list.tbl.getValue("HSDVO_B0"))
		        			+ Number(list.tbl.getValue("HSTVO_B0"));
		        var SUME0   = Number(list.tbl.getValue("HSDPO_E0"))
		        			+ Number(list.tbl.getValue("HSTPO_E0"))
		        			+ Number(list.tbl.getValue("HSTSO_E0"))
		        			+ Number(list.tbl.getValue("HSDVO_E0"))
		        			+ Number(list.tbl.getValue("HSTVO_E0"));
		        var SUMNA   = Number(list.tbl.getValue("HSDPO_NA"))
		        			+ Number(list.tbl.getValue("HSTPO_NA"))
		        			+ Number(list.tbl.getValue("HSTSO_NA"))
		        			+ Number(list.tbl.getValue("HSDVO_NA"))
		        			+ Number(list.tbl.getValue("HSTVO_NA"));
		        var SUMINA  = Number(list.tbl.getValue("HSDPO_INA"))
		        			+ Number(list.tbl.getValue("HSTPO_INA"))
		        			+ Number(list.tbl.getValue("HSTSO_INA"))
		        			+ Number(list.tbl.getValue("HSDVO_INA"))
		        			+ Number(list.tbl.getValue("HSTVO_INA"));
		        var SUMITN  = Number(list.tbl.getValue("HSDPO_ITN"))
		        			+ Number(list.tbl.getValue("HSTPO_ITN"))
		        			+ Number(list.tbl.getValue("HSTSO_ITN"))
		        			+ Number(list.tbl.getValue("HSDVO_ITN"))
		        			+ Number(list.tbl.getValue("HSTVO_ITN"));
		        var SUMNR   = Number(list.tbl.getValue("HSTPO_NR"))
		        			+ Number(list.tbl.getValue("HSTSO_NR"))
		        			+ Number(list.tbl.getValue("HSTVO_NR"))
		        			+ Number(list.tbl.getValue("HSDPO_NR"))
		        			+ Number(list.tbl.getValue("HSDVO_NR"));
		        var SUMIT   = Number(list.tbl.getValue("HSTPO_IT"))
		        			+ Number(list.tbl.getValue("HSTSO_IT"))
		        			+ Number(list.tbl.getValue("HSTVO_IT"))
		        			+ Number(list.tbl.getValue("HSDPO_IT"))
		        			+ Number(list.tbl.getValue("HSDVO_IT"));       
		        var SUMIV   = Number(list.tbl.getValue("HSTPO_IV"))
		        			+ Number(list.tbl.getValue("HSTSO_IV"))
		        			+ Number(list.tbl.getValue("HSTVO_IV"))
		        			+ Number(list.tbl.getValue("HSDPO_IV"))
		        			+ Number(list.tbl.getValue("HSDVO_IV"));
		        
		        var SUMND   = Number(list.tbl.getValue("HSTPO_NDS"))
		        			+ Number(list.tbl.getValue("HSTSO_NDS"))
		        			+ Number(list.tbl.getValue("HSTVO_NDS"))
		        			+ Number(list.tbl.getValue("HSDPO_NDS"))
		        			+ Number(list.tbl.getValue("HSDVO_NDS"));
		        var SUMNAN  = Number(list.tbl.getValue("HSTPO_NAN"))
		        			+ Number(list.tbl.getValue("HSTSO_NAN"))
		        			+ Number(list.tbl.getValue("HSTVO_NAN"))
		        			+ Number(list.tbl.getValue("HSDPO_NAN"))
		        			+ Number(list.tbl.getValue("HSDVO_NAN"));
		        var SUMNNR  = Number(list.tbl.getValue("HSTPO_NNR"))
		        			+ Number(list.tbl.getValue("HSTSO_NNR"))
		        			+ Number(list.tbl.getValue("HSTVO_NNR"))
		        			+ Number(list.tbl.getValue("HSDPO_NNR"))
		        			+ Number(list.tbl.getValue("HSDVO_NNR"));
		        var SUMNO   = Number(list.tbl.getValue("HSTPO_NO"))
		        			+ Number(list.tbl.getValue("HSTSO_NO"))
		        			+ Number(list.tbl.getValue("HSTVO_NO"))
		        			+ Number(list.tbl.getValue("HSDPO_NO"))
		        			+ Number(list.tbl.getValue("HSDVO_NO"));
		        var SUMIND  = Number(list.tbl.getValue("HSTPO_IND"))
		        			+ Number(list.tbl.getValue("HSTSO_IND"))
		        			+ Number(list.tbl.getValue("HSTVO_IND"))
		        			+ Number(list.tbl.getValue("HSDPO_IND"))
		        			+ Number(list.tbl.getValue("HSDVO_IND"));
		                 
		        oPar.isReg  = true;
		        oPar.Fwid   = list.tbl.getValue("FWID");
		        oPar.Fid_doc= list.tbl.getValue("HID_DOC");
		        oPar.SUM = SUM00 + SUM20 + SUMA0 + SUMB0 + SUME0 
		        		 + SUMXX + SUMNA + SUMINA + SUMITN + SUMNR 
		        		 + SUMIT + SUMIV;
		        oPar.NDS = SUMND + SUMNAN + SUMNNR + SUMNO + SUMIND;
     		}
     		/*
     		switch (oPar.Fdoc)
     		{
      			case "OT":
      			case "NK":
         			editTask = "E_NK.HTM";
         			break;
			    case "VZ":
			    case "VR":
			    	editTask = "E_VR.HTM";
			        break;
			    case "PU":
			    case "SM":
			    	editTask = "E_SM.HTM";
			        break;
			    case "SF":
			    case "VP":
			    case "VM":
			    case "PM":
			    case "PZ":
			    case "TZ":
			    case "PN":
			    case "OC":
			    	editTask = "E_" + oPar.Fdoc + ".HTM";
			        break;
			    case "SR":
			    	editTask = "E_SRR.HTM";
			        break;
			    default:
			    	editTask = "E_REGEKZ.HTM";
     		}     
     		showWindow(editTask, SW_MODAL, oPar);
     		*/     		
     		oPar.Fid = list.tbl.getValue("HID_DOC");
     		var oDoc = new DpDoc(oPar.Fdoc, oPar.Fnop);
			oDoc.edit(oPar.mode, oPar.Fid, oPar);
			/*
			ExecuteSQL("UPDATE "+ sDocregTbl +" SET HORG="+ oDoc.getVar("HORG")
					+" WHERE HID_DOC="+ oDoc.getID());
			*/	
			break;  
  
  		case "PRINT1":
      		/*include("objects/DpTVars.js");
      		var tv;
      		tv = new DpTVars();
      		var tblH;
      		var tblR;
      		var print1Flag = true;
      		var prn1Name   = "";
      		var m_doc,m_nop;
      
      		if (docinfo("ISNAKL", list.tbl.getValue("Hdoc")))
      		{
            	m_doc = list.tbl.getValue("Hdoc").toUpperCase();
            	m_nop = list.tbl.getValue("Hnop");
               
            	prn1Name = m_doc.toLowerCase() + "_ex";
            	tblH = OpenTable("m", "SELECT *"
                           + " FROM ^SCH_ZAG"
                           + " WHERE fwid = " + sqlTo(list.tbl.getValue("Hid_doc"))
                        );
 
            	tblR = OpenTable("m", "SELECT *"
                           + " FROM ^ANLTK"
                           + " WHERE fid_doc = " + sqlTo(list.tbl.getValue("Hid_doc"))
                        );
         
            	if (SQL)
            	{
					tblR.tie("cl_edi","edi","FCOD","fedi");
				   	tblR.tie("cl_nmk","nmk","FCOD","fnmkl");
				}
				else
				{
					tblR.tie("cl_edi","edi","cod","fedi");
				   	tblR.tie("cl_nmk","nmk","cod","fnmkl");
				}
				
            	tv.setPatt(prn1Name);
            	tv.setDoc(m_doc,m_nop);
            	tblH.extTie("H", m_doc, m_nop);
            	tv.setHTbl(tblH);
            	tblR.extTie("R", m_doc, m_nop);
            	tv.setRTbl(tblR);
            	tv.print();
      		}
      		else
      		{
         		tblR = OpenTable("m", "SELECT *"
                           + " FROM ^RDOCREG"
                           + " WHERE fid_doc = " + sqlTo(list.tbl.getValue("Fid_doc"))
                        );
         
            	if (SQL)
            	{
					tblR.tie("cl_edi","edi","FCOD","fedi");
					tblR.tie("cl_nmk","nmk","FCOD","fnmkl");
				}
				else
				{
					tblR.tie("cl_edi","edi","cod","fedi");
					tblR.tie("cl_nmk","nmk","cod","fnmkl");
				}
         
	         	include("objects/DpTVars.js");   
	         	var tv = new DpTVars("rnk_ex");	         	
	         	var h = new Object();
	         	h.FDAT = list.tbl.getValue("Hdoc_dat");
	         	h.FORG = list.tbl.getValue("Horg");
	         	tv.setHTbl(h);
	         	tv.setRTbl(tblR);
	         	tv.print();	         	
      		}*/
      		
      		include("objects/DpTVars.js");
			include("doc/DpDoc.js");
			var m_doc = list.tbl.getValue("Hdoc");
            var m_nop = list.tbl.getValue("Hnop");
			var vars = new DpTVars("DOC", m_doc);
			
			if (this.dataSrc.getSelectedCount() > 0)
			{
				var selIDs = this.dataSrc.getSelectedIDs();
			
				var tmpTbl = getTmpTableName();
				ExecuteSQL("CREATE TABLE " + tmpTbl 
					+ "(" + this.tbl.getIdFld() + " " + SqlType("LONG") + ")");
				var batch = createBatch();
				for (var nid = 0; nid < selIDs.length; nid++)
				{
					sSQL = "INSERT INTO " + tmpTbl 
						+ " VALUES(" + sqlTo(selIDs[nid]) + ")";
					batch.addBatch(sSQL);
				}
				batch.execute(false);
				var prtTbl = OpenTable("s",tmpTbl);
				vars.setRTbl(prtTbl);
				print_Progress = getProgressMonitor();
				print_Progress.beginTask("Print",prtTbl.getRecordCount());
				vars.print(true);
				prtTbl.close();
				DropTable(tmpTbl);
			}	
			else
			{
				var oDoc = new DpDoc(m_doc, m_nop);			
				if (!oDoc.loadByID(this.tbl.getValue("HID_DOC"),false,true))
					return false;			
				vars.setDoc(m_doc, m_nop);
				vars.eval.setJDoc(oDoc);
				if (oDoc.hasRows())
				{
					vars.eval.setRowTable(oDoc.jDoc.getRowTable("ROW"));
				}
				vars.print();
			}       
      		break; 
      		 
      	/* нужно переписывать 
   		case "NN":		//Перевести в NN
			var nNop = input("Номер папки", 0);
			sSql = "insert into ^HNN (fid_doc,fdoc_dat,fdoc_num,fbase_doc,fbase_nop"
						+",fwid,fdoc,Fnop)"
					+" select (fid_doc,fdoc_dat,fdoc_num,fdoc as fbase_doc,fnop as fbase_nop"
						+","+GetUID()+" as fwid, 'NN' as fdoc, "+nNop+" as Fnop)"
					+" from "+ sDocregTbl 
					+" where " + DataSource().sqlSelected()
						+ " and Hisnov1="+ SqlFalse;
			ExecuteSQL(sSql);			
			break;
		*/
		case "REREG":
			if (confirm("ВНИМАНИЕ!!!"
					+ "\nВ процессе перерегистрации могут нарушиться связки, созданные вручную"
					+ "\nВы уверены, что нужно перерегистрировать данные за весь период?"))
			{
				reregistration();
				list.tbl.requery();	
				grid.refresh();
				
			}
			break;
		
		case "SETNEWVIDP": 
		case "SETNEWVIDE":
			WAIT(UR("Зміна типів накладних . . . |Изменение типов накладных . . . "));
			var listTbl = OpenTable("select * from "+ sDocregTbl +" where "+ grid.sqlSelected());
			var rowCount = listTbl.recordCount;
			var sInd = (ID=="SETNEWVIDP"? "П" : "Е");
			var nDoc = 0;
			var nRow = 0;
			for(; !listTbl.isEOF(); listTbl.moveNext())
			{
				WAIT(UR("Зміна типів накладних: |Изменение типов накладных: ")+ (++nDoc));
				var rowID = Number(listTbl.getValue("FWID"));
				var sVid = listTbl.getValue("HVID_DOC");
				sVid = String(sVid).trim().toUpperCase();
				if(sVid=="ПН" || sVid=="РК")
					sVid += sInd;
				else if(sVid=="ПНУ")
					sVid = "ПН"+ sInd +"У";
				else if(sVid=="РКУ")
					sVid = "РК"+ sInd +"У";
				else if(sVid=="ВМД")
					sVid = "МД"+ sInd;
				else if(sVid=="ВДМУ" || sVid=="ВМДУ")
					sVid = "МД"+ sInd +"У";
				else
					continue;
				var bRet = ExecuteSQL("update "+ sDocregTbl +" set HVID_DOC="+ sqlTo(sVid) +" where FWID="+ rowID);
				if(bRet)
					nDoc++;
			}
			list.tbl.requery();
			grid.refresh();
			CLEARWAIT();
			alert("ГОТОВО!");
			break;
	}
}

function linkGroup()
{
    var doptbl = new Object();
    var doptab = new Object();
    var dopch = new Object();
    var t1 = list.tbl
    var morg = t1.getValue("Horg");
    var mgroup = t1.getValue("Hgroup");
    var dopzm1 = 0;
    //var nReg = Number(m_Reg.substr(1));
    
    DropTable("KONTR_A");
    DropTable("KONTR_B");

	strSQL="CREATE TABLE KONTR_B("
			+ "FORG " + SqlType("LONG") + ", "
			+ "FGROUP " + SqlType("TEXT", 25) + ", "
			+ "FIDDEAL " + SqlType("LONG") + ")";
	ExecuteSQL(strSQL);
	
	strSQL="INSERT INTO KONTR_B(FORG,FGROUP,FIDDEAL) " +
			" SELECT B.HORG AS FORG,B.HGROUP AS FGROUP,B.HIDDEAL AS FIDDEAL "+
			" FROM "+ sDocregTbl 
			+" B WHERE " + sqlStrIsNotEmp("B.HIDDEAL") +
				" AND B.HREG="+ sqlTo(m_Reg) +
			" GROUP BY B.HORG,B.HGROUP,B.HIDDEAL";
	ExecuteSQL(strSQL);

	strSQL="CREATE TABLE KONTR_A("
			+ "FORG " + SqlType("LONG") + ", "
			+ "FGROUP " + SqlType("TEXT", 25) + ", "
			+ "FIDDEAL " + SqlType("COUNTER") + ", "
			+ "FCNTDEAL " + SqlType("LONG") + ")";
	ExecuteSQL(strSQL);

	strSQL="INSERT INTO KONTR_A(FORG,FGROUP,FIDDEAL,FCNTDEAL) " +
			" SELECT B.HORG AS FORG,B.HGROUP AS FGROUP,B.HIDDEAL AS FIDDEAL,"+
				" (SELECT COUNT(*) FROM KONTR_B A WHERE "+
				" A.FORG=B.HORG AND A.FGROUP=B.HGROUP) " +
				" AS FCNTDEAL FROM "+ sDocregTbl +" B " +
			" WHERE " + sqlStrIsEmp("B.HIDDEAL") +
				" AND B.HREG="+ sqlTo(m_Reg) +
			" GROUP BY B.HORG,B.HGROUP,B.HIDDEAL";
	ExecuteSQL(strSQL);
/*
   	if (SUBD == ORACLE || SUBD == DERBY)
	{
		ExecuteSQL("DROP INDEX forg", false);
	}
   	strSQL="CREATE INDEX forg ON KONTR_A(FORG,FGROUP)";
    ExecuteSQL(strSQL);

   	strSQL="CREATE INDEX forg ON KONTR_B(FORG,FGROUP)";
    ExecuteSQL(strSQL);
/*
	doptab = OpenTable("s","KONTR_B");
	doptab.index = "forg";
	if (SQL)
		doptab.index="FORG,FGROUP";

	doptbl = OpenTable("s","KONTR_A");
	doptbl.index = "forg";
	if (SQL)
		doptbl.index = "FORG,FGROUP";

	if (!(doptbl.IsBOF && doptbl.IsEOF))
		doptbl.MoveFirst();	
/*	
	while (!doptbl.isEOF())
	{
		doptbl.Edit();

		if (doptbl("Fcntdeal")==0)
			doptbl("Fiddeal") = GetUID();
		else if (doptbl("Fcntdeal")==1)
		{
			var zzm1 = doptbl("Forg");
			var zzm2 = doptbl("Fgroup");

			if (doptab.Seek("=", zzm1,zzm2))
				doptbl("Fiddeal")=doptab("Fiddeal");
		}
		else 
		{
			if (SQL)
				doptbl("Fiddeal") = id00;
			else
				doptbl("Fiddeal") = "";
		}

		doptbl.Update();
		doptbl.MoveNext();
	}

	doptbl.Close();
	doptab.Close();
*/
	ExecuteSQL("UPDATE KONTR_A SET Fiddeal=0 WHERE Fcntdeal<>0");
    ExecuteSQL("UPDATE KONTR_A SET Fiddeal=(SELECT MAX(b.Fiddeal) "
    				+" FROM KONTR_B b "
    				+" WHERE b.Forg=KONTR_A.Forg and b.Fgroup=KONTR_A.Fgroup)"
    			+" WHERE Fcntdeal=1");
    
	strSQL = "UPDATE "+ sDocregTbl
			+ " SET HIDDEAL = (SELECT MAX(FIDDEAL) FROM KONTR_A "
				+" WHERE FORG="+ sDocregTbl +".HORG AND FGROUP="+ sDocregTbl +".HGROUP)"			
			+" WHERE HREG = " + sqlTo(m_Reg) +" AND " + sqlStrIsEmp("HIDDEAL");
	ExecuteSQL(strSQL);
	
	strSQL=	"UPDATE "+ sDocregTbl +
		" SET HIDDEAL = (SELECT  " +
			" MAX(FIDDEAL) FROM KONTR_A " +
			" WHERE FORG="+ sDocregTbl +".HORG " +
				" AND FGROUP="+ sDocregTbl +".HGROUP) " +
		" WHERE EXISTS (SELECT  " +
			" FIDDEAL FROM KONTR_A a " +
			" WHERE FORG="+ sDocregTbl +".HORG " +
				" AND FGROUP="+ sDocregTbl +".HGROUP " +
				" AND "+ sDocregTbl +".HREG = " + sqlTo(m_Reg) +
				" AND " + sqlStrIsEmp(sDocregTbl +".HIDDEAL") + ")";		
	ExecuteSQL(strSQL);
	
	dopzm1 = 0;
	strSQL = "SELECT COUNT(*) AS KILK FROM "+ sDocregTbl 
		" WHERE " + sqlStrIsEmp("HIDDEAL") + " AND HREG="+ sqlTo(m_Reg);
	dopch = getSnap(strSQL);
	if(dopch!=null)
		dopzm1 = dopch[0];

	//dopch.Close();

	strSQL="Пропущено записей для которых возможно более 1 связи - "+dopzm1;
//	alert(strSQL);
}

function grid_isprov()
{
	/*
	var isSch = toScrObj(list.tbl.getValue("HSCH"));
	if (isSch)
		return true;
	*/
	//return false;	
	var oSnap = getSnap("SELECT FWID FROM ^schet where fdoc= '_R' and fid_doc=" + list.tbl.getValue("hid_doc"));
	if (oSnap != null)
		return true;
	return false;
}

function onPrnList(tv)
{
	var zmbDate = list.objAsk.dat1;
	var zmeDate = list.objAsk.dat2;

	var captDat1 = StrDat(zmbDate, "DMY");
	var captDat2 = StrDat(zmeDate, "DMY");

	var h = new Object();
	h.FCAPTDAT1 = captDat1;
	h.FCAPTDAT2 = captDat2;
	tv.setHTbl(h);
}

// Объект для расчета переменных регистраций
// Используется grid'ом
function DocSums()
{
   	this.resum = DocSums_resum;
   	this.v1dcsum = DocSums_v1dcsum;
   	this.v1dcnds = DocSums_v1dcnds;
   	this.v1dcnsum = DocSums_v1dcnsum;
   	this.v2dcsum = DocSums_v2dcsum;
   	this.v2dcnds = DocSums_v2dcnds;
   	this.v2dcnsum = DocSums_v2dcnsum;
}

var DocSums_resum_oEval;
function DocSums_resum()
{
   	var tbl = list.tbl;
   	if(this.fid_doc != tbl.getValue("Hid_doc"))
   	{
      	this.fid_doc = tbl.getValue("Hid_doc");
		if(!DocSums_resum_oEval)
			DocSums_resum_oEval = new DpEval();
      	with(DocSums_resum_oEval)
      	{
			setTable(tbl);
			eval("v1n=jrv('v1dcnds')");
			eval("v1s=jrv('v1dcsum')");
			eval("v2n=jrv('v2dcnds')");
			eval("v2s=jrv('v2dcsum')");
			this.v1s = getVar("v1s");
			this.v1n = getVar("v1n");
			this.v2s = getVar("v2s");
			this.v2n = getVar("v2n");
      	}
   	}
}

function DocSums_v1dcnsum()
{
   	this.resum();
   	return this.v1s + this.v1n;
}

function DocSums_v1dcsum()
{
   	this.resum();
   	return this.v1s;
}

function DocSums_v1dcnds()
{
   	this.resum();
   	return this.v1n;
}

function DocSums_v2dcnsum()
{
   	this.resum();
   	return this.v2s + this.v2n;
}

function DocSums_v2dcsum()
{
   	this.resum();
   	return this.v2s;
}

function DocSums_v2dcnds()
{
   	this.resum();
   	return this.v2n;
}

function reregistration()
{
	include("doc\\DpDoc.js")
	include("sys\\docinfo.js")
			
	ExecuteSQL(
		"DELETE FROM " + sDocregTbl 
			+ " WHERE hdat BETWEEN " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)
			+ " AND HREG=" + sqlTo(m_Reg)
			+ " AND hdoc<>'SLDREGM'"
		)			
			
	var sSearch = String("S" + (m_Vid=="+"?"P":"M") + m_Reg).toUpperCase();
	var sFile = getOrgPath() + "settings/journals/register";
	var file = new DpFile(sFile);
	if (!file.exists()) return;
	var docs = file.listFiles();
	for (var i = 0; i < docs.length; i++)
	{
		var docFldr = docs[i];
		if (!docFldr.isDirectory())
			continue;
			
		var sDoc = docFldr.getName();
		var opers = docFldr.listFiles();
		
		for (var j = 0; j < opers.length; j++)
		{
			var operFldr = opers[j];
			if (!operFldr.isDirectory())
				continue;
				
			var oper = operFldr.getName();
			
			var sReg = operFldr.getAbsolutePath() + "/" + sSearch;
			var regFile = new DpFile(sReg);

			if (regFile.exists() && regFile.isDirectory())
			{
				var oDoc = new DpDoc(sDoc, oper);
				var tDocs = OpenTable(
					"SELECT *"
					+ " FROM ^" + oDoc.getTableName()
					+ " WHERE fdoc=" + sqlTo(sDoc)
						+ " AND fnop=" + sqlTo(oper)
						+ " AND fdoc_dat BETWEEN " + sqlTo(list.objAsk.dat1)
							+ " AND " + sqlTo(list.objAsk.dat2)
					)	
				//browse(tDocs)
				
				//setProgressRange(0, tDocs.recordCount);
				var pos = 0;
				for( ; !tDocs.IsEOF(); tDocs.MoveNext())
				{
					//setProgressPos(pos++, sDoc + "/" + oper);
					
					oDoc.loadByID(tDocs.getValue("FWID"));
					
					oDoc.doRegistration();				
				}
				//setProgressPos(0);
				
				tDocs.close();
			}
		}
	}	
}

include("sys\\DpList.js");