// JScript source code
var list	= null;
include ("Objects/DpCtrlLinker.js");

function DpBaseDlg()
{
	this.bSaving = false;
	Task.setList(this);
	
	this.load = DpBaseDlg_load;
	this.save = DpBaseDlg_save;
	this.apply = DpBaseDlg_apply;
	this.escape = DpBaseDlg_escape;
	this.exit = DpBaseDlg_exit;
	this.addCtrl = DpBaseDlg_addCtrl;
	this.addTab = DpBaseDlg_addTab;
	this.getExtTab = DpBaseDlg_getExtTab;
	this.getExtPanel = DpBaseDlg_getExtPanel;
	this.buildExtTab = DpBaseDlg_buildExtTab;
	this.buildObjExtTab = DpBaseDlg_buildObjExtTab;
	this.saveExt = DpBaseDlg_saveExt;
	this.buildDocLabelsTabs = DpBaseDlg_buildDocLabelsTabs;
	this.saveDocLabels = DpBaseDlg_saveDocLabels;	
	this.isSaving = DpBaseDlg_isSaving;
	this.validateAll = DpBaseDlg_validateAll;
	this.eval = DpBaseDialog_eval;
	this.initControls = DpBaseDlg_initControls;
	this.initObject = DpBaseDlg_initObject;
	this.stdFillObject = DpBaseDlg_stdFillObject;
	this.getVarName = DpBaseDlg_getVarName; 
	this.addExternalDocs = DpBaseDlg_addExternalDocs;
	this.getDocNop =DpBaseDlg_getDocNop;
	this.buildDocRegAttrTab = DpBaseDlg_buildDocRegAttrTab;
	this.createNalReqHeader = DpBaseDlg_createNalReqHeader;
	this.createNalReqRow = DpBaseDlg_createNalReqRow;
	this.saveDocRegAttrs = DpBaseDlg_saveDocRegAttrs;
	this.fillReq = DpBaseDlg_fillReq;
	this.vidNaklZaval = DpBaseDlg_vidNaklZaval;
	this.setEscapeMsg = DpBaseDlg_setEscapeMsg;
	this.setHelp = DpBaseDlg_setHelp;
	this.applyChanges = DpBaseDlg_applyChanges;
	
	this.mass_edit_init = DpBaseDlg_mass_edit_init;
	this.massUpdate = DpBaseDlg_massUpdate;
	this.fillMassEditObject = DpBaseDlg_fillMassEditObject;
	this.getValue = DpBaseDlg_getValue;
	this.reset_all_value = DpBaseDlg_reset_all_value;
	
	this.loadParentDocRows = DpBaseDlg_loadParentDocRows;
	this.rowGridMenuInit = DpBaseDlg_rowGridMenuInit;
	this.rowGridMenuRun = DpBaseDlg_rowGridMenuRun;
	
	this.nop_combo_valid = DpBaseDlg_nop_combo_valid;
	
	this.addTopicTab = DpBaseDlg_addTopicTab;
	this.addTopicField = DpBaseDlg_addTopicField;
	this.topicSelect = DpBaseDlg_topicSelect;
	this.topicsTab_listener = DpBaseDlg_topicsTab_listener;
	this.arrTopic = new Array();
	this.topicsGrid = null;
	
	
	this.initSysPrint = DpBaseDlg_initSysPrint;
	this.runPrint = DpBaseDlg_runPrint;
	this.validOnlyVisibleCtrls = false;
	this.controlsLinker = null;
	
	this.isDoc = false;
	this.isObj = false;
	var e;
	try
	{
	if (extPar)
		extPar.escape = true;
	}
	catch (e) {
		// TODO: handle exception
	}
	
	this.nullTxt = "";
	
	this.sMode = "";
	this.arrSc = new Array();
	this.arrFields = new Array();
	//vlad
	//Массив меток контролов, которые являются аналитиками расширений-счетов.
	//Нужен для того, чтобы при сохранении брать не ctrl.getValue(), а брать 
	//у соответствующего счета getCl1() - getCl3()
	//В противном случае у нас нет возможности корректно сохранить
	//значения аналитик-номенклатур и договоров.
	//Индекс - ID контрола. 
	//Хранить будем объект с такими полями: 
	//	grp - индекс из this.arrSc
	//	an - номер аналитики
	//Те контролы, которые найдутся в массиве сначала будут пропущены, 
	//а затем будет обойден массив arrSc и значения будут сняты методами
	//getCl1() - getCl3() у DpSc
	this.arrScAnalitics = new Array();
		 
	//fruckt
    //раньше это были локальные переменные в DpBaseDlg_addCtrl
	//Для возможности отрисовки расширений счет - ан.3 в одну строку
	//пришлось навесить на this
	this.arrSort = new Array();
	this.extPos = 0;

	this.arrDocRows = new Array();
	this.arrTab = new Array();
}

function DpBaseDlg_load()
{	
	if(extPar && extPar.m_pTable)
	{ 
	 	extPar.tblSrc = extPar.m_pTable;
	 	this.controlsLinker = new DpCtrlLinker(extPar.tblSrc, true);
	}
		
	if(extPar && extPar.mode) 
		extPar.sMode = extPar.mode;
	
	if(extPar)
	{
		if(extPar.sMode) 
			this.sMode = extPar.sMode;
		else
			this.sMode = null;
			
		if(extPar.tblSrc)
		{ 
			this.sOldFWID = toScrObj(extPar.tblSrc.getValue("FWID"));
			if(this.sMode == "ADD" ||  this.sMode == "COPY" || this.sMode == "ADDFLD")
				this.sFWID = GetUID();
			else
				this.sFWID = this.sOldFWID;
		}
	}
		
	if(FORM.setMode)
		FORM.setMode(this.sMode);

	if(typeof(onLoad)=="function")
		this.onLoad = onLoad;
	else
		this.onLoad = empty;
		
	if(typeof(Load)=="function")	
		this.onLoad = Load;		
		
	if(typeof(onSave)=="function")
		this.onSave = onSave;
	else
		this.onSave = null;
		
	if(typeof(onEscape)=="function")
		this.onEscape = onEscape;
	else
		this.onEscape = empty;

	if(typeof(onExit)=="function")
		this.onExit = onExit;
	else
		this.onExit = empty;

	if (extPar && extPar.doc && objTypeOf(extPar.doc)== "DpDoc" )	
	{
		if (inList(this.sMode, "EDIT", "VIEW") && typeOf(FORM) == "DpXMLDialog")
		{
			this.docKey = extPar.doc.sDocLbl + "|" + Number(extPar.doc.getID());
			lpProxy.getShellMap().put(this.docKey, FORM.getShell());
			
		}
		
		this.setHelp("docs_" + extPar.doc.sDocLbl);
		this.isDoc = true;
		this.controlsLinker = new DpCtrlLinker(extPar.doc);
		
		if(typeof NOP_COMBO!="undefined")
		{
			NOP_COMBO.clear();
			var tblOP = OpenTable("select FNOP, FTXT "
								+" from ^CL_LNK "
								+" where FDOC="+ sqlTo(extPar.doc.sDocLbl)
									+" and FNOP>0"
								+" order by FNOP"
								);
			var firstNop = 0;
			for(; !tblOP.isEOF(); tblOP.MoveNext())
			{
				var nop = java.lang.Integer(tblOP.getValue("FNOP"));
				if (!firstNop)
					firstNop = nop;
				var txt = UR(tblOP.getValue("FTXT"));
				NOP_COMBO.addItem(nop, nop +" - "+ txt);
			}			
			tblOP.close();
			
			if(NOP_COMBO.getLength()<=0)
			{
				var sName = extPar.doc.getName();
				NOP_COMBO.addItem("1", sName);				
			}
			
			NOP_COMBO.setValue(firstNop?firstNop:1);
			if(extPar.doc.nNop)
				NOP_COMBO.setValue(extPar.doc.nNop);
			
			var nop = NOP_COMBO.getValue();
			if (nop != extPar.doc.getVar("HOP"))
			{
				extPar.doc.setVar("HOP", nop);
				extPar.hasTab = true;
				extPar.doc.extTbl = null;
				extPar.doc.extTbl0 = null;
				extPar.doc.arrRegNums = null;
			}
						
			var sTxt = UR("Вибір папки|Выбор папки");	
			NOP_COMBO.getCtrl().setToolTipText(sTxt);
			
			setValid(NOP_COMBO, this, "nop_combo_valid");
			
			//if(this.sMode=="EDIT")
			//	Disable(NOP_COMBO);			
		}
		else if (extPar.doc.getVar("HOP") == 0)
		{
			var nop = this.getDocNop(extPar.doc.sDocLbl);
			if (nop != 0)
			{
				extPar.doc.setVar("HOP", nop);
				extPar.hasTab = true;
				extPar.doc.extTbl = null;
				extPar.doc.extTbl0 = null; 
				extPar.doc.arrRegNums = null;
			}
		}
		
		//if (extPar.hasTab)
		{
			if (extPar.doc.hasExt())
			{
				this.extCtrlMap = new Array();
				this.buildObjExtTab();
	
			}
			if (extPar.doc.getRegNums().length > 0 && extPar.doc.getPar("mfisnktax"))
			{
				this.buildDocRegAttrTab();
			}
		}
		
		this.buildDocLabelsTabs();
		
		setDocCaption();
		this.initSysPrint(extPar.doc);
		
		if(typeof NAME!="undefined")
		{
			var sName = extPar.doc.eval("ONAME");
			if(sName && sName!="")
				NAME.setText(sName);
			else
				NAME.setText(extPar.doc.getOName());
		}
		
		this.addTopicTab();		
		this.addExternalDocs();
		
		//this.loadParentDocRows(extPar.doc);
	}
	else if (extPar && extPar.obj && objTypeOf(extPar.obj)== "DpDocRow")	
	{
		this.isDoc = true;
		extPar.doc = extPar.obj;
		this.controlsLinker = new DpCtrlLinker(extPar.obj);
		if (extPar.obj.hasExt())
		{
			this.extCtrlMap = new Array();
			this.buildObjExtTab();
		}			
	}
	else if (extPar && extPar.dpObj)
	{
		this.isObj = true;
		this.controlsLinker = new DpCtrlLinker(extPar.dpObj);
		if (extPar.dpObj.hasExt())
		{
			this.extCtrlMap = new Array();
			this.buildObjExtTab();
		}
	}
	
	
	if (typeof(extPar) == "object" && extPar.title)
	{
		Caption(extPar.title);
	}
	
	if (typeof(extPar) != "undefined" && extPar 
			&& typeof(extPar.ret) == "object")
	{
			for (var i in extPar.ret)
			{
				if (typeof(document[i]) == "object"
					&& typeof(document[i].value) != "undefined")
				{
					document[i].value = extPar.ret[i];	
				}
			}
	}
	
	if (typeof(FORM.getData) != "undefined")
	{
		var sText = FORM.getData("text");
		if (sText)
		{
			Caption(UR(sText),this.sMode);
		}
	}
	
	this.initControls();   
	if (this.controlsLinker != null)
	{
		if (!this.controlsLinker.isTable || this.sMode != "ADD")		
			this.controlsLinker.toControls();
	}
	if(this.onLoad()===false)
	{
		this.exit();
		return;
	}


	if (extPar && typeof(extPar.mode) == "string"
		&& extPar.isView
		&& typeof(btnOK) == "object")
		{			
			btnOK.setEnabled(false);
			if(typeof(btnApply) == "object")
			{
				btnApply.setEnabled(false);
			}
		}
		
	if (extPar && extPar.ExtAliases)
	{
		this.extCtrlMap = new Array();
		this.buildExtTab();	
	}
	
	if (typeof(HID_DOG)=="object")
	{
		include ("Objects\\DpCntrct.js");
		var oDoc = extPar.doc;
		if(!oDoc && extPar.obj)
			oDoc = extPar.obj;
		// eugene 16.02.2012 Обработка параметра документа "Запретить проводить документ без договора"
		var useDog = false;
		if(oDoc.getPar)
			useDog = toScrObj(oDoc.getPar("docprovnotdog"));
		var modeDog = useDog ? "+" : "0";
		this.oCntr = new DpCntrct(modeDog, dpDoc_getOrg);
		this.oCntr.linkCtrl(HID_DOG);
		var codOrg = oDoc.getVar("HORG");
		if(typeof(FORG)=="object")
			this.oCntr.setOrg(FORG.value);
		if(this.oOrg)
		{
			this.oCntr.setCl(this.oOrg);
			this.oCntr.setOrg(this.oOrg.getCod());
		}
		var dogVid = "";
		if(oDoc.getPar)
			dogVid = oDoc.getPar("_cntrct_vid");
		if(dogVid)
			this.oCntr.setVid(dogVid);
		if (oDoc.getVar("HID_DOG"))
		{
			this.oCntr.setID(oDoc.getVar("HID_DOG"));
		}
		if(extPar.Fid_dog)
			this.oCntr.setID(extPar.Fid_dog);
		if(typeof(updateCntrct)=="function")
			this.oCntr.subUpdate = updateCntrct;
		extPar.oCntr = this.oCntr;
	}


	if (typeof(HDAT)=="object")
		setValid(HDAT, HDAT_Valid)
	else if (typeof(FDOC_DAT)=="object")
		setValid(FDOC_DAT, HDAT_Valid)
	
	if(typeof(MYORG)=="object" && extPar)
	{
		var codMyOrg = getPar("CODMYORG");
		this.oMyOrg = new DpCl("", codMyOrg, 0);
		this.oMyOrg.linkSmartCtrl(MYORG);
		this.oMyOrg.setCod(getPar("ORGNOM"));
		var oDoc = extPar.doc;
		if(oDoc && oDoc.getVar("HORG0"))
			this.oMyOrg.setCod(oDoc.getVar("HORG0"));
		if(typeof(GR_MYORG)=="object")
		{
			if(this.oMyOrg.singleCod)
				GR_MYORG.setVisible(false);						
			else
				GR_MYORG.setVisible(true);
		}
	}
	
	if(extPar!=null && extPar.escapeMsg && extPar.escapeMsg!="")
		this.setEscapeMsg(extPar.escapeMsg);


	if(typeof(onAfterLoad) == "function")
		this.onAfterLoad = onAfterLoad;
	else
		this.onAfterLoad = empty;

	this.onAfterLoad();	
	
	var t = new Date().getTime();
	handleEvent("afterDialogLoad", this);
	t = new Date().getTime() - t;
	//alert(t);
	
	if (extPar && extPar.doc && objTypeOf(extPar.doc)=="DpDoc" )	
	{
		//для маркетинговых списков
		if(extPar.subMode=="FORMBYML")
		{
			var orgVar = extPar.doc.getVar("attr.FLDORG");
			if(orgVar)
			{
				orgVar = String(orgVar).trim();
				var oLinker = extPar.doc.getCtrlLinker();
				if(oLinker)
				{
					var oCL = oLinker.arrCL[orgVar];				
					if(oCL)
					{
						oCL.setMode("0!");
						oCL.setCod(0);
						if(oCL.ctrlSmart)
							Disable(oCL.ctrlSmart);
						if(oCL.ctrlCod)
							Disable(oCL.ctrlCod);						
					}
				}
			}
		}
	}
	
	if(this.sMode=="MASS_EDIT")
	{
		this.nullTxt = "-";
		
		try
		{
			if(typeof(btnReset)!="undefined")
			{
				var sReset = UR("ОЧИСТИТИ УСІ ЗНАЧЕННЯ|ОЧИСТИТЬ ВСЕ ЗНАЧЕНИЯ");
				btnReset.getCtrl().setText(sReset);
				btnReset.getCtrl().setVisible(true);
				setButton(btnReset, this, "reset_all_value");
				
				var gd = new Packages.org.eclipse.swt.layout.GridData();
				gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.BEGINNING;
				gd.grabExcessHorizontalSpace = true;
				gd.widthHint = 200;
				btnReset.setLayoutData(gd);
				
				FORM.Refresh();
			}
		}
		catch(e)
		{
			
		}
		this.selectObjVars = selectObjVars;
		this.mass_edit_handler = mass_edit_handler;
		this.mass_edit_handler_out = mass_edit_handler_out;
				
		this.mass_edit_init();
	}
}

function DpBaseDlg_nop_combo_valid()
{
	var txt = NOP_COMBO.getStringValue();
	var nop = java.lang.Integer(NOP_COMBO.value);	
	if(nop==Number(extPar.doc.nNop))
		return;
	
	if(this.sMode=="EDIT")
	{
		var oSnap = getSnap("SELECT FWID FROM ^SCHET"
							  + " WHERE FID_DOC=" + sqlTo(extPar.doc.getID())
							  );
		if(oSnap)
		{
			var sMsg = UR("Документ має проведення."
							+"\nПісля збереження документу до іншої папки"
								//+" старі проведення будуть вилучені."
								+" потрібно переформувати проведення."
						+"|Документ имеет проводки."
							+"\nПосле сохранения документа в другую папку"
								//+" старые проводки будут удалены."
								+" нужно переформировать проводки."
						);
			alert(sMsg);
		}
	}
		
	if(txt)
	{
		var sCaption = String(txt);
		if (extPar.mode)
			sCaption += ": "+ modeName(extPar.mode);
		Caption(sCaption);
	}
	
	try
	{
		var tabFolder = FORM.getTabFolder();
		if(tabFolder && this.arrTab.length>0)
		{
			var nTab = 0;
			var maxTab = 0;
			for(var i in this.arrTab)
			{
				if(nTab==0)
					nTab = i;
				maxTab = i;
			}
			var n = nTab;
			while(n++<=maxTab)
			{
				if(nTab<=tabFolder.getItemCount())
					tabFolder.getItem(nTab).dispose();
			}
		}
	}
	catch(e)
	{
		//alert(e, 2);
	}
	
	try
	{
		if (this.extPanel != null && !this.extPanel.isDisposed())
			this.extPanel.dispose();
	}
	catch(e)
	{		
	}
	
	this.extPanel = null;
	this.extTab = null;
	
	this.arrTab = new Array();
	this.extCtrlMap = new Array();
	
	extPar.doc.arrRegNums = null;	
	extPar.doc.extTbl = null;
	extPar.doc.setVar("HOP", nop);
	extPar.doc.jDoc.setVar("HOP", java.lang.Integer(nop));	
	extPar.doc.jDoc.getObjPar().setNop(java.lang.String(nop));
	
	if(extPar.doc.hasExt())
		this.buildObjExtTab();
	//extPar.hasTab = true;
	if (extPar.doc.getRegNums().length > 0 && extPar.doc.getPar("mfisnktax"))
		this.buildDocRegAttrTab();
	this.buildDocLabelsTabs();
	if(this.sMode=="MASS_EDIT")
	{
		this.mass_edit_init();
		NOP_COMBO.value = nop;
	}
	
	if(typeof onChangeNop == "function")
	{
		this.onChangeNop = onChangeNop;
		this.onChangeNop();
	}
}

function DpBaseDlg_mass_edit_init()
{
	var arrCtrl = FORM.getControls();
	for (var i = 0; i < arrCtrl.length; i++)
	{
		try
		{
			var oCtrl = eval(String(arrCtrl[i]));	
			if (typeof(oCtrl)=="undefined" || !oCtrl)
				continue;
			
			if(typeOf(oCtrl)=="DpTable")
			{
				oCtrl.getCtrl().removeAll();
				oCtrl.getCtrl().setEnabled(false);				
				continue;
			}
			
			if(typeOf(oCtrl)=="DpGrid")
			{
				if(!oCtrl.getTable().isEmpty())
				{
					ExecuteSQL("delete from "+ oCtrl.getTable().getTableName(), false);
					oCtrl.getTable().requery();
					oCtrl.refresh();
				}
				oCtrl.getTableControl().setEnabled(false);
				var color = oCtrl.getParent().getBackground();
				//oCtrl.getTableControl().setBackground(color);
				continue;
			}
			if(oCtrl.getMask)
			{				
				var mask = oCtrl.getMask();
				if(mask && mask.indexOf("#")!=-1)
				{
					oCtrl.setData("TYPE", "number");
					mask = mask.replaceAll("#", "&");					
					oCtrl.setMask(mask);
				}
			}
			if(oCtrl.setEnabled)
				oCtrl.setEnabled(true);
			if(oCtrl.setValue)
				oCtrl.setValue(null);			
			if(typeOf(oCtrl)=="DpTextEx")
			{
				oCtrl.setValue(this.nullTxt);
				setWhen(oCtrl, mass_edit_when);
				massEditContAssist(oCtrl);
			}
			if(typeOf(oCtrl)=="DpCombo" || typeOf(oCtrl)=="DpRate")
			{
				oCtrl.setSelectedIndex(oCtrl.getLength()-1);
				if(oCtrl.getValue()!="null")
					oCtrl.addItem("null", this.nullTxt);
				oCtrl.setSelectedIndex(oCtrl.getLength()-1);
			}
			if(typeOf(oCtrl)=="DpDate" || typeOf(oCtrl)=="DpDateTime")
			{
				oCtrl.setValue(null);
				//oCtrl.setStrValue(null);
				//oCtrl.getCtrl().setText("");				
			}
						
			if(oCtrl.setModifyHandler)
			{				
				if(typeOf(oCtrl)=="DpCheck")
					oCtrl.setModifyHandler(this, "mass_edit_handler", "mass_edit_handler_out");
				else
					oCtrl.setModifyHandler(this, "mass_edit_handler");
				mass_edit_handler(oCtrl, true);
			}
		}
		catch(e)
		{
			trace(oCtrl +": "+ e);
		}
	}
}

function DpBaseDlg_reset_all_value()
{
	var arrCtrl = FORM.getControls();
	for (var i = 0; i < arrCtrl.length; i++)
	{
		try
		{
			var oCtrl = eval(String(arrCtrl[i]));	
			if (typeof(oCtrl)=="undefined" || !oCtrl)
				continue;
			
			if(typeOf(oCtrl)=="DpTable")
			{
				oCtrl.getCtrl().removeAll();
				continue;
			}
			
			if(typeOf(oCtrl)=="DpGrid")
			{
				if(!oCtrl.getTable().isEmpty())
				{
					ExecuteSQL("delete from "+ oCtrl.getTable().getTableName(), false);
					oCtrl.getTable().requery();
					oCtrl.refresh();
				}
				oCtrl.getTableControl().setEnabled(false);			
				continue;
			}
					
			if(oCtrl.setValue)
				oCtrl.setValue(null);
			
			if(typeOf(oCtrl)=="DpTextEx")
			{
				oCtrl.setValue(this.nullTxt);				
			}
			
			if(typeOf(oCtrl)=="DpCombo" || typeOf(oCtrl)=="DpRate")
			{
				oCtrl.setSelectedIndex(oCtrl.getLength()-1);
			}
			
			if(typeOf(oCtrl)=="DpDate" || typeOf(oCtrl)=="DpDateTime")
			{
				oCtrl.setValue(null);				
			}
			
			if(typeOf(oCtrl)=="DpCheck")
			{
				oCtrl.getCtrl().setGrayed(true);
				oCtrl.checked = true;				
			}
		}
		catch(e)
		{
			trace(oCtrl +": "+ e);
		}
	}
}

function DpBaseDlg_initControls()
{
	if (typeof(FORM.getControls) != "function")
	{
		return;	 
	}
	ctrls = FORM.getControls();	
	for (var i = 0; i < ctrls.length; i++)
	{
		
		var oCtrl = null;
		oCtrl = document[String(ctrls[i])];
		if (!oCtrl || typeof(oCtrl.getData) != "function")
			continue;
			
		
		
		var sMask = oCtrl.getData("mask");
		var mask = null;
		if (sMask && String(sMask).startsWith("MASK"))
		{
			mask = document[String(sMask)];
		}
		
		if (mask)
		{	
			oCtrl.setMask(mask);
		}
			
		var sValidFunc = oCtrl.getData("validFunc");
		if (sValidFunc)
		{
			sValidFunc = String(sValidFunc);
			var func = document[sValidFunc];
			
			if (typeof(func) == "function")
			{
				this[sValidFunc] = func;				
				setValid(oCtrl, this, sValidFunc);
			}
		}
		
		var fieldName = this.getVarName(oCtrl);
		var objectType = oCtrl.getData("objectType");
		if (extPar && extPar.tblSrc && fieldName && !objectType)
		{
			this.controlsLinker.addLink(fieldName,oCtrl);						
		}
		
		if (objectType)
		{
			this.initObject(String(objectType), oCtrl, String(ctrls[i]))
		}
		
	}	
}

function DpBaseDlg_getVarName(oCtrl)
{
	var oData = oCtrl.getData("var");
	if(!oData)		
		oData = oCtrl.getData("field");	
	
	if (oData)
		return String(oData);
	return null;	
}

function DpBaseDlg_initObject(objectType, oCtrl, idCTRL)
{
	fieldName = this.getVarName(oCtrl);
	var isTbl = extPar && extPar.tblSrc && fieldName;
	
	if (objectType.equalsIgnoreCase("DpClNo"))
	{
		include("objects\\DpClNo.js");
		
		 
		if (extPar && extPar.tblSrc && fieldName)
		{
			new DpClNo(this.sMode,oCtrl, extPar.tblSrc.getTableName() , String(oCtrl.getData("field")),this.sOldFWID);
			
			this.controlsLinker.addLink(fieldName,oCtrl)			
		}		
		return;
	}
	
	if (objectType.equalsIgnoreCase("DpVal") || objectType.equalsIgnoreCase("cls.valut"))
	{
		include("Objects/DpVal.js");
		var ID = getIDObject(oCtrl, idCTRL)		
		document[ID] = this[ID] = new DpVal();
		document[ID].linkCtrl(oCtrl);
		
				 				
	}
	
	if (objectType.equalsIgnoreCase("DpEdi") || objectType.equalsIgnoreCase("cls.edi"))
	{
		include("Objects/DpEdi.js");
		var ID = getIDObject(oCtrl, idCTRL)
		document[ID] = this[ID] = new DpEdi();
		document[ID].linkCtrl(oCtrl);
		 				
	}
	
	if (objectType.equalsIgnoreCase("DpClcl"))
	{
		include("Objects/DpClcl.js");
		var ID = getIDObject(oCtrl, idCTRL)
		document[ID] = this[ID] = new DpClcl();
		document[ID].linkCtrl(oCtrl);		 				
	}
	
	if (objectType.equalsIgnoreCase("DpNmkl") || objectType.equalsIgnoreCase("cls.nmkl"))
	{
		include("Objects/DpNmkl.js");
		var ID = getIDObject(oCtrl, idCTRL)
		document[ID] = this[ID] = new DpNmkl();
		document[ID].linkCtrl(oCtrl);		 				
	}
	
	if (objectType.equalsIgnoreCase("DpCL"))
	{
		include("Objects/DpCl.js");
		var ID = getIDObject(oCtrl, idCTRL);
		var nCL = DpBaseDlg_getNomCl(oCtrl)
		var oCL = new DpCl();
		oCL.setClcl(nCL);
		document[ID] = this[ID] = oCL;	
		document[ID].linkCtrl(oCtrl);		 				
	}
	
	this.controlsLinker.addClLink(fieldName, document[ID]);		
	
	
}

function DpBaseDlg_getNomCl(oCtrl)
{
	var nCL = oCtrl.getData("nomcl")
	if(isNaN(nCL))
	{
		var val = getPar(nCL);
		if (isNaN(val))
			return 0;
		return Number(val);			
	}
	return Number(nCL);
}

function getIDObject(oCtrl, idCTRL)
{
	var ID = oCtrl.getData("objectID");
	
	if (!ID)
	{
		ID = "obj" + oCtrl.getData("ID");
	}
	return ID;	
}

function DpBaseDlg_stdFillObject(m)
{
	var ret = false;
	
	if (this.arrFields == null)
		return false;
	
	for (var fld in this.arrFields)
	{
		m[fld.toUpperCase()] = this.arrFields[fld].value;
		ret = true;
	}	
	
	return ret;	
}

function mass_edit_when(oCtrl)
{
	if(oCtrl && oCtrl.getCtrl)
	{
		var sVal = String(oCtrl.getValue());
		if(sVal)
			oCtrl.getCtrl().setSelection(0, sVal.length);
	}
}

function mass_edit_handler_out(oCtrl)
{
	try
	{
		if(typeOf(oCtrl)=="DpCheck")
		{
			if(oCtrl.getCtrl().getGrayed())
				oCtrl.checked = true;			
			//trace("out_checked: "+ (oCtrl.checked))
			//trace("out_Grayed: "+ (oCtrl.getCtrl().getGrayed()))
		}
	}
	catch(e)
	{
		trace(e.toString());
	}
}

function mass_edit_handler(oCtrl, bInit)
{	
	try
	{		
		if(!oCtrl || (typeof(oCtrl.getValue)=="undefined" && typeof(oCtrl.getText)=="undefined"))
			return;
		var oVal = null;
		if(oCtrl.getText)
			oVal = oCtrl.getText();
		else if(oCtrl.getValue)
			oVal = oCtrl.getValue();		
		var sVal = String(oVal).trim();
		if(sVal=="=")
		{
			//после '=' можно ввести выражение
			oCtrl.setMask(strRepl("&", 250));
			//setButton(oCtrl, this, "selectObjVars");	//проблемы с завалом в справочники
		}
		var editRGB = lpProxy.getDpAPI().rgb(0xFFFFFF);
		var nullRGB = lpProxy.getDpAPI().rgb(0xFFFDDD);			
		if((typeOf(oCtrl)=="DpTextEx" || typeOf(oCtrl)=="Combo") && sVal==this.nullTxt)
			oVal = null;
		if(typeOf(oCtrl)=="DpCheck")
		{
			//var color = oCtrl.getCtrl().getParent().getBackground();
			//oCtrl.getCtrl().setBackground(color);
			if(bInit)
			{
				oCtrl.getCtrl().setGrayed(true);
				oCtrl.checked = true;				
			}
			else if(oCtrl.checked==true)
			{
				if(oCtrl.getCtrl().getGrayed())
					oCtrl.getCtrl().setGrayed(false);					
				else
					oCtrl.getCtrl().setGrayed(true);					
			}
			else
			{
				oCtrl.getCtrl().setGrayed(false);
			}
			//trace("in_checked: "+ (oCtrl.checked))	
			//trace("in_Grayed: "+ (oCtrl.getCtrl().getGrayed()))					
			return;
		}
		if(typeOf(oCtrl)=="DpDate" || typeOf(oCtrl)=="DpDateTime")
		{
			sVal = String(oCtrl.getCtrl().getText()).trim();
			if(sVal.indexOf("пуст")!=-1)
				oVal = null;
		}		
		if(bInit || oVal==null || sVal=="null")
		{				
			var color = org.eclipse.swt.graphics.Color(null, nullRGB);
			//var color = oCtrl.getCtrl().getParent().getBackground();
			if(oCtrl.setBackground)
				oCtrl.setBackground(color);
			else
				oCtrl.getCtrl().setBackground(color);
		}
		else
		{			
			var color = org.eclipse.swt.graphics.Color(null, editRGB);
			if(oCtrl.setBackground)
				oCtrl.setBackground(color);
			else
				oCtrl.getCtrl().setBackground(color);
				
			if(oCtrl.getData("ID")=="NOP_COMBO")
				this.nop_combo_valid();
		}		
	}
	catch(e)
	{
		trace(e.toString());
	}
}

function massEditContAssist(oCtrl)
{
	if(extPar && (extPar.dpObj || extPar.doc))
	{
		this.fillSmartAssist = fillSmartAssist;
		this.smartSelected = smartSelected;
		oCtrl.setContentAssistHandler(this, "fillSmartAssist", "smartSelected", new Array(100,300));
	}
}

function fillSmartAssist(ca, oCtrl)
{
	var sVal = "";
	if(oCtrl && oCtrl.getValue)
		sVal = String(oCtrl.getValue()).trim();
	if(sVal=="=")
		fillSmartObjVars(ca, oCtrl);
}

//список переменных для выражений в массовом редактировании объектов
function fillSmartObjVars(ca, oCtrl)
{
	if(!extPar)
		return;
	var obj = extPar.dpObj;
	if(!obj && extPar.doc)
		obj = extPar.doc;
	if(!obj)
		return;
	if(obj.hasExt())
	{
		var extInfoMap = obj.getExtInfo();
		for (var extLbl in extInfoMap)
		{
			var ext = extInfoMap[extLbl];
			var sText = ext.E_FieldText;
			ca.addItem("ext."+ extLbl, new Array(extLbl, sText));
		}
	}
	ca.addItem("LOADVARLIST", new Array("------------", UR("Список змінних|Список переменных")));
}

function smartSelected(sVal, oCtrl)
{
	if(sVal=="LOADVARLIST")
		this.selectObjVars(oCtrl.getCtrl());
	else
		insertObjVar(oCtrl.getCtrl(), sVal);
}

function selectObjVars(oCtrl)
{
	var tbl = createObjectTable();
	var obj = extPar.dpObj;
	if(!obj && extPar.doc)
		obj = extPar.doc;
	var varsInfo = obj.getVarsInfo();
	for(var i=0; i<varsInfo.length; i++)
	{
		tbl.AddNew();
		tbl.setValue("FWID", tbl.recordCount+1);
		tbl.setValue("FVAR", varsInfo[i].name);
		tbl.setValue("FTXT", varsInfo[i].rem);
		tbl.Update();
	}
	if(obj.hasExt())
	{
		var extInfoMap = obj.getExtInfo();
		for (var extLbl in extInfoMap)
		{
			var ext = extInfoMap[extLbl];
			tbl.AddNew();
			tbl.setValue("FWID", tbl.recordCount+1);
			tbl.setValue("FVAR", "ext."+ extLbl);
			tbl.setValue("FTXT", ext.E_FieldText);
			tbl.Update();
		}
	}
	
	var par = new Object();
	par.tbl = tbl;
	par.noSel = true;
	par.title = UR("Список змінних|Список переменных");
	par.ret = new Object();
	par.ret.FVAR = "";
	par.ret.FTXT = "";
	
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FVAR";
	par.cells[1].width = 15;
	par.cells[1].text = UR("Змінна|Переменная");
	
	par.cells[2] = new Object();
	par.cells[2].name = "FTXT";
	par.cells[2].width = 30;
	par.cells[2].text = UR("Назва|Наименование");
			
	showWindow("selection.xml", SW_MODAL, par);
	if(par.escape)
		return "";
	
	var sVar = par.ret.FVAR;
	if(oCtrl)
		insertObjVar(oCtrl, sVar);
	return sVar;
}

function insertObjVar(oCtrl, sVar)
{
	var pos = oCtrl.getCaretPosition();
	oCtrl.setSelection(pos);
	oCtrl.insert(sVar);
	var str = String(oCtrl.getText()).trim();
	if(!str.startsWith("="))
		oCtrl.setValue("="+str);
}

function setDocCaption()
{			
	if (extPar.mode)
		Caption(extPar.doc.getCaption() + ": " + modeName(extPar.mode));
	else
		Caption(extPar.doc.getCaption());
}

function DpBaseDlg_addCtrl(ExtTab,FI,alias)
{
	var label = FI.E_Label;
	var type = String(FI.getType());
	var text = FI.E_FieldText;
	if (!text || String(text).trim() == "")
		text = label;
		
	var ctrlName = (alias == "#"?"X":alias) + "_" + label;
	var value;
	var dlgBuilder = FORM.getDialogBuilder();
	
	if (this.isDoc)
		value = extPar.doc.getExt(label);
	else if (this.isObj)
		value = extPar.dpObj.getExt(label);
	else
	{
		if (extPar && (extPar.sMode == "EDIT" || extPar.mode == "EDIT" || extPar.mode == "COPY" || extPar.sMode == "COPY"))
			value = extPar.tblSrc.getValue(alias + (alias=="#"?"":".") + label);
		else
			value = null;
		if (!value)
		{
			value = FI.E_Default;
		}
	}
	
	value = toScrObj(value);
	if ("BOOL" == type)
	{		
		var ctrl = dlgBuilder.addCheckBox(ExtTab,ctrlName,text);
		ctrl.setValue(value != 0);
		this.extCtrlMap[ctrlName] = ctrl;
	}
	if ("CURRENCY" == type || "INT" == type || "FLOAT" == type
			 || "TEXT" == type || "LONGTEXT" == type)
		 {
		 	var width = Number(FI.E_Width)*8;
		 	if(!width)
		 		width = ("TEXT"==type?150:70);
		 	if(width>500)
		 		width = 500;
 			 		
		 	var ctrl = dlgBuilder.addTextField(ExtTab,ctrlName,text,width);		 	
			var sFormat = String(FI.E_Format);			
			var sMask = getExtMask(type, sFormat);
			ctrl.setMask(sMask);
			
			ctrl.setValue(value);
		 	this.extCtrlMap[ctrlName] = ctrl;
		 	
		 	if(FI.E_isCheck==true && typeof(ctrl)!="undefined")
				setValid(ctrl, ext_text_valid);
		 }
	else if (type.length >= 2
			&& ("SC" == type.substring(0,2)
			|| "SU" == type.substring(0,2)
			|| "ST" == type.substring(0,2)
			|| "C1" == type.substring(0,2)
			|| "C2" == type.substring(0,2)
			|| "C3" == type.substring(0,2)))
		{
			include("objects\\DpSc.js");

			var grp = type.substring(2);
			//vlad
			//Теперь за один раз нарисуем все контролы, касающиеся данного oSc (у них идентичная grp)
		 	//var oSc = new DpSc("00");
		 	var oSc;
		 	if(this.arrSc[grp]==null)
		 	{
			 	oSc = new DpSc();
		 		this.arrSc[grp] = oSc;
		 	}
		 	else
			{
		 		oSc = this.arrSc[grp];
			}

			var width = new Array();
			var ids = new Array();
			var val = new Array();
			var kol = 1;
				
			// счет
			width[kol] = 70;
			ids[kol] = ctrlName;
			oSc.setMode("c");
			if(FI.E_isCheck!=true)
			{
				oSc.setMode(oSc.getMode() +"00");
			}
			val[kol] = value;

			if (this.arrSort[this.extPos+kol])
			{
				var type = String(this.arrSort[this.extPos+kol].getType());
				if (type.length >= 2 && "SU" == type.substring(0,2) && grp == type.substring(2))
				{
					var label = this.arrSort[this.extPos+kol].E_Label;
					var ctrlName = (alias == "#"?"X":alias) + "_" + label;
					kol++;
					width[kol] = 70;
					ids[kol] = ctrlName;
					
					oSc.setMode("cu");
					if(this.arrSort[this.extPos+kol-1].E_isCheck!=true)
					{
						oSc.setMode(oSc.getMode() +"00");
					}

					if (this.isDoc)
					{
						val[kol] = extPar.doc.getExt(label);
					}
					else if (this.isObj)
					{
						val[kol] = extPar.dpObj.getExt(label);
					}
				}
			}

			// статья
			if (this.arrSort[this.extPos+kol])
			{
				var type = String(this.arrSort[this.extPos+kol].getType());
				if (type.length >= 2 && "ST" == type.substring(0,2) && grp == type.substring(2))
				{
					var label = this.arrSort[this.extPos+kol].E_Label;
					var ctrlName = (alias == "#"?"X":alias) + "_" + label;
					kol++;
					width[kol] = 70;
					ids[kol] = ctrlName;

					oSc.setMode("cut");
					if(this.arrSort[this.extPos+kol-1].E_isCheck!=true)
					{
						oSc.setMode(oSc.getMode() +"00");
					}

					if (this.isDoc)
					{
						val[kol] = extPar.doc.getExt(label);
					}
					else if (this.isObj)
					{
						val[kol] = extPar.dpObj.getExt(label);
					}
				}
			}

			// аналитика 1
			if (this.arrSort[this.extPos+kol])
			{
				var type = String(this.arrSort[this.extPos+kol].getType());
				if (type.length >= 2 && "C1" == type.substring(0,2) && grp == type.substring(2))
				{
					var label = this.arrSort[this.extPos+kol].E_Label;
					var ctrlName = (alias == "#"?"X":alias) + "_" + label;
					kol++;
					width[kol] = 70;
					ids[kol] = ctrlName;
					
					oSc.setMode(oSc.getMode()+"x");
					oSc.cl[0] = new DpzSelect("N" + (this.arrSort[this.extPos+kol-1].E_isCheck==true? "" : "0"));

					if (this.isDoc)
					{
						val[kol] = extPar.doc.getExt(label);
					}
					else if (this.isObj)
					{
						val[kol] = extPar.dpObj.getExt(label);
					}
					this.arrScAnalitics[ctrlName] = {grp:grp,an:1};
				}
			}

			// аналитика 2
			if (this.arrSort[this.extPos+kol])
			{
				var type = String(this.arrSort[this.extPos+kol].getType());
				if (type.length >= 2 && "C2" == type.substring(0,2) && grp == type.substring(2))
				{
					var label = this.arrSort[this.extPos+kol].E_Label;
					var ctrlName = (alias == "#"?"X":alias) + "_" + label;
					kol++;
					width[kol] = 70;
					ids[kol] = ctrlName;

					oSc.setMode(oSc.getMode()+"y");
					oSc.cl[1] = new DpzSelect("N" + (this.arrSort[this.extPos+kol-1].E_isCheck==true? "" : "0"));

					if (this.isDoc)
					{
						val[kol] = extPar.doc.getExt(label);
					}
					else if (this.isObj)
					{
						val[kol] = extPar.dpObj.getExt(label);
					}
					this.arrScAnalitics[ctrlName] = {grp:grp,an:2};
				}
			}
				
			// аналитика 3
			if (this.arrSort[this.extPos+kol])
			{
				var type = String(this.arrSort[this.extPos+kol].getType());
				if (type.length >= 2 && "C3" == type.substring(0,2) && grp == type.substring(2))
				{
					var label = this.arrSort[this.extPos+kol].E_Label;
					var ctrlName = (alias == "#"?"X":alias) + "_" + label;
					kol++;
					width[kol] = 70;
					ids[kol] = ctrlName;

					oSc.setMode(oSc.getMode()+"z");
					oSc.cl[2] = new DpzSelect("N" + (this.arrSort[this.extPos+kol-1].E_isCheck==true? "" : "0"));

					if (this.isDoc)
					{
						val[kol] = extPar.doc.getExt(label);
					}
					else if (this.isObj)
					{
						val[kol] = extPar.dpObj.getExt(label);
					}
					this.arrScAnalitics[ctrlName] = {grp:grp,an:3};
				}
			}

			//текстовка
			width[kol+1] = 250;
			ids[kol+1] = "SCTXT";

			dlgBuilder.addNMsEdit(ExtTab, text, ids, width, kol+1);

			var ctrlC = null;
			var ctrlU = null;
			var ctrlT = null;
			var ctrlX = null;
			var ctrlY = null;
			var ctrlZ = null;

			if (kol >= 1)
			{
				ctrlC = FORM.getControl(ids[1])
				this.extCtrlMap[ids[1]] = ctrlC;
			}
			if (kol >= 2)
			{
				ctrlU = FORM.getControl(ids[2])
				this.extCtrlMap[ids[2]] = ctrlU;
			}
			if (kol >= 3)
			{
				ctrlT = FORM.getControl(ids[3])
				this.extCtrlMap[ids[3]] = ctrlT;
			}
			if (kol >= 4)
			{
				ctrlX = FORM.getControl(ids[4])
				this.extCtrlMap[ids[4]] = ctrlX;
			}
			if (kol >= 5)
			{
				ctrlY = FORM.getControl(ids[5])
				this.extCtrlMap[ids[5]] = ctrlY;
			}
			if (kol >= 6)
			{
				ctrlZ = FORM.getControl(ids[6])
				this.extCtrlMap[ids[6]] = ctrlZ;
			}

			oSc.linkCtrl(ctrlC, ctrlU, ctrlT, ctrlX, ctrlY, ctrlZ);
			oSc.linkCtrlTxt(FORM.getControl("SCTXT"));
			oSc.set(val[1], val[2], val[3], val[4], val[5], val[6]);
			
			//fruckt
			//при входе в функцию мы уже стоим на позиции SC
			//this.extPos += kol;
			this.extPos += kol - 1;
/*
			var ctrl = dlgBuilder.addTextField(ExtTab,ctrlName,text,70);
			var grp = type.substring(2);
			type = type.substring(0,2);
		 	include("objects\\DpSc.js");
            //vlad
		 	//var oSc = new DpSc("00");
		 	var oSc;
		 	if(this.arrSc[grp]==null)
		 	{
			 	oSc = new DpSc("00");
		 		this.arrSc[grp] = oSc;
		 	}
		 	else
		 		oSc = this.arrSc[grp];
		 	
		 	if (type == "SC")
		 	{
			 	if(FI.E_isCheck==true)
			 		oSc.setMode(oSc.getMode() +"c");
			 	oSc.linkCtrl(ctrl);
			 	oSc.set(value);
			 	//oSc.getValue = new Function(" return this.getSc();");
			}
			else if (type == "SU")
			{
				if(FI.E_isCheck==true)
					oSc.setMode(oSc.getMode() +"u");
				oSc.linkCtrlSu(ctrl);
				
				//var oSt = getSnap("SELECT FSCHET FROM ^cl_schet WHERE FSUBSCHET=" + sqlTo(value));
				//var stVal = 0;
				//if (oSt != null)
				//	stVal = oSt[0];
				//oSc.set(stVal,value);
				//oSc.getValue = new Function(" return this.getSu();");
				
				oSc.set(oSc.getSc(), value);
			}
			else if (type == "ST")
			{
				if(FI.E_isCheck==true)
					oSc.setMode(oSc.getMode() +"t");
				oSc.linkCtrlSt(ctrl);
				oSc.set(oSc.getSc(), oSc.getSu(), value);
				//oSc.getValue = new Function(" return this.getSt();");				
			}
			else if (type == "C1")
			{				
				//if(FI.E_isCheck==true)
				//vlad 
				var subMode = /0/.test(oSc.getMode()) ? "00": "";
				oSc.setMode("cut"+subMode+"x");
				//else
				//	oSc.setMode("x");
				oSc.ctrlCl1 = ctrl;
                //vlad
				//oSc.cl[0] = new DpCl("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[0] = new DpzSelect("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[0].linkCtrl(ctrl);				
				oSc.set(oSc.getSc(), oSc.getSu(), oSc.getSt(), value);
				this.arrScAnalitics[ctrlName] = {grp:grp,an:1};
			}
			else if (type == "C2")
			{	
				//if(FI.E_isCheck==true)
				//vlad 
				var subMode = /0/.test(oSc.getMode()) ? "00": "";
				oSc.setMode("cut"+subMode+"y");
				//else
				//	oSc.setMode("y");			
				oSc.ctrlCl2 = ctrl;
                //vlad
				//oSc.cl[1] = new DpCl("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[1] = new DpzSelect("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[1].linkCtrl(ctrl);
				
				//if(oSc.cl[0])
				//{
				//	oSc.cl[1].IsSuperCl = true;
				//	oSc.cl[1].superCl = oSc.cl[0];
				//}				
				
				oSc.set(oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1(), value);	
				this.arrScAnalitics[ctrlName] = {grp:grp,an:2};
			}
			else if (type == "C3")
			{				
				//if(FI.E_isCheck==true)
				//vlad 
				var subMode = /0/.test(oSc.getMode()) ? "00": "";
				oSc.setMode("cut"+subMode+"z");
				//else
				//	oSc.setMode("z");
				oSc.ctrlCl3 = ctrl;
				//vlad 
				//oSc.cl[2] = new DpCl("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[2] = new DpzSelect("N" + (FI.E_isCheck==true? "" : "0"));				
				oSc.cl[2].linkCtrl(ctrl);
				
				//if(oSc.cl[1])
				//{
				//	oSc.cl[2].IsSuperCl = true;
				//	oSc.cl[2].superCl = oSc.cl[1];
				//}
				
				oSc.set(oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1(), oSc.getCl2(), value);	
				this.arrScAnalitics[ctrlName] = {grp:grp,an:3};
			}
			
			this.extCtrlMap[ctrlName] = oSc;
*/

			//fruckt
			//this.extCtrlMap[ctrlName] = ctrl;
		}
		else if ("NMK" == type)
		{
			dlgBuilder.addTextField(ExtTab,ctrlName,text,300);
			
			include("objects\\DpNmkl.js");
		 	var objNmk = new DpNmkl(Number(value),"c0");
		 	objNmk.CanEmpty = true;
		 	if(FI.E_isCheck==true)
		 		objNmk.CanEmpty = false;
		 	var ctrl = eval(ctrlName);
		 	
		 	objNmk.linkSmartCtrl(ctrl);
		 	objNmk.getValue = new Function(" return this.getCod();");
		 	objNmk.setCod(value);
		 	this.extCtrlMap[ctrlName] = objNmk;
		 }
	if (type.substring(0,1) == "A")
		 {
		 	
			var width = Number(FI.E_Width)*8;
		 	if(!width)
		 		width = 300;
		 	if(width>500)
		 		width = 500;
		 	else if (width < 200)
		 		width = 200;

		 	dlgBuilder.addTextField(ExtTab,ctrlName,text,width);
		 	var ctrl = eval(ctrlName);		 	
		 	var clcl = parseInt(type.substring(1));
		 	include("objects\\DpCl.js");
		 	var objCl = new DpCl(FI.E_isCheck==true?"":"0");
		 	objCl.linkSmartCtrl(ctrl);
		 	objCl.setClcl(clcl);	 
		 	objCl.setContAssist();
		 	
		 	objCl.getValue = new Function(" return this.getCod();");
		 	objCl.setCod(value);
		 	
		 	this.extCtrlMap[ctrlName] = objCl;
		 }
	if (type.substring(0,7) == "CNTRCT#")
	{
		dlgBuilder.addTextField(ExtTab,ctrlName,text,100);
	 	var ctrl = eval(ctrlName);
	 	include("objects\\DpCntrct.js");
	 	if (!this.arrCntrctInfo)
	 		this.arrCntrctInfo = new Array();
	 	this.arrCntrctInfo[ctrlName]= type.substring(7);
	 	var getorgFnc = new Function("return list.eval(list.arrCntrctInfo['" +ctrlName + "'])");
	 	
	 	var objCl = new DpCntrct("+*", getorgFnc);
	 	objCl.linkCtrl(ctrl);
	 	
	 	objCl.getValue = new Function(" return this.getCod();");
	 	objCl.setID(value);	 	
	 	this.extCtrlMap[ctrlName] = objCl;
	}
	if (type.substring(0,3) == "R0#")
		 {
			
			dlgBuilder.addTextField(ExtTab,ctrlName,text,300);
		 	var ctrl = eval(ctrlName);		 	
		 	var clcl = type.substring(3);
		 	var n = clcl.indexOf("#")
		 	var sVar = clcl.substring(n+1);
		 	var clcl = parseInt(clcl);
		 	include("objects\\DpCl.js");
		 	var objCl = new DpCl(FI.E_isCheck==true?"U0-":"U",clcl, value, getVarsEval, sVar);
		 	objCl.linkSmartCtrl(ctrl);
		 	objCl.setClcl(clcl);	 
		 	objCl.setContAssist();
		 	
		 	objCl.getValue = new Function(" return this.getCod();");
		 	objCl.setCod(value);
		 	
		 	this.extCtrlMap[ctrlName] = objCl;
		
		/*
			var widths = new Array();
		 	widths[1] = 100;
		 	widths[2] = 200;
		 	var IDs = new Array();
		 	IDs[1] = ctrlName + "0";
		 	IDs[2] = ctrlName + "1";
			dlgBuilder.addNMsEdit(ExtTab,text,IDs,widths,2);
		 	var clcl = type.substring(3);
		 	var n = clcl.indexOf("#")
		 	var sVar = clcl.substring(n+1);
		 	var clcl = parseInt(clcl);
		 	include("objects\\DpCl.js");
		 	var objCl = new DpCl("U",clcl, value, getVarsEval, sVar);
		 	//objCl.setClcl(clcl);
		 	//objCl.setCod(value);
		 	var ctrl0 = eval(ctrlName + "0");
		 	var ctrl1 = eval(ctrlName + "1");
		 	objCl.linkCtrl(ctrl0,ctrl1);
		 	objCl.getValue = new Function(" return this.getCod();");
		 	if(FI.E_isCheck==true)
		 		objCl.setMode("U0-");
		 		
		 	var sFormat = String(FI.E_Format);
			var sMask = getExtMask("INT", sFormat);
			if(sMask!="")
				ctrl0.setMask(sMask);
		 	
		 	this.extCtrlMap[ctrlName] = objCl;
		 */	
		 }	 

	else if ("RS" == type)
		 {
		 	var widths = new Array();
		 	widths[1] = 120;
		 	widths[2] = 80;
		 	widths[3] = 250;
		 	var IDs = new Array();
		 	IDs[1] = ctrlName + "0";
		 	IDs[2] = ctrlName + "1";
		 	IDs[3] = ctrlName + "2";
			dlgBuilder.addNMsEdit(ExtTab,text,IDs,widths,3);
		 	include("objects\\DpRasSc.js");
		 	var objRS = new DpRasSc();
		 	var ctrl0 = eval(ctrlName + "0");
		 	var ctrl1 = eval(ctrlName + "1");
		 	var ctrl2 = eval(ctrlName + "2");
		 	objRS.linkCtrl(ctrl0,ctrl1,ctrl2);
		 	objRS.setRasSc(value);		 	
			//ctrl0.setValue(value);
		 	this.extCtrlMap[ctrlName] = ctrl0;
		 }
	else if ("V" == type)
		 {
		 	var widths = new Array();
		 	widths[1] = 100;
		 	widths[2] = 200;
		 	var IDs = new Array();
		 	IDs[1] = ctrlName + "0";
		 	IDs[2] = ctrlName + "1";
			dlgBuilder.addNMsEdit(ExtTab,text,IDs,widths,2);
		 	include("objects\\DpVal.js");
		 	var objVal = new DpVal();
		 	objVal.setCod(value);
		 	var ctrl0 = eval(ctrlName + "0");
		 	var ctrl1 = eval(ctrlName + "1");
		 	objVal.linkCtrl(ctrl0,ctrl1);
		 	objVal.getValue = new Function(" return this.getCod();");
		 	this.extCtrlMap[ctrlName] = objVal;		 	
		 }
	else if ("DATETIME" == type)
		 {
			var ctrl = dlgBuilder.addDate(ExtTab,ctrlName,text);
			ctrl.setValue(value);
			this.extCtrlMap[ctrlName] = ctrl;
			if(FI.E_isCheck==true && typeof(ctrl)!="undefined")
				setValid(ctrl, ext_date_valid);
		 }
	if(FI.E_isCulc==true && typeof(ctrl)!="undefined")
		Disable(ctrl);	
				 
	ExtTab.pack();

}

function getExtMask(type, sFormat)
{
	var sMask = "";
	if ("CURRENCY" == type || "FLOAT" == type)
	{	
		var nDec = 0;
		if(sFormat.indexOf(".")!=-1)
			nDec = Number(sFormat.substring(1, sFormat.indexOf(".")));
		else
			nDec = parseInt(sFormat.substring(1));
		if (isNaN(nDec))
			nDec = 10;				
		sMask = "-";
		for(var n=0; n<nDec; n++)
			sMask += "#";
		sMask += ".";
		nDec = Number(sFormat.substring(sFormat.indexOf(".")+1, sFormat.length-1));
		for(var n=0; n<nDec; n++)
			sMask += "#";
		if (sMask.endsWith("."))
			sMask = sMask.substring(0, sMask.length-1);
		if(sMask=="")
			sMask = "#";	
	}
	else if ("INT" == type || "TEXT" == type)
	{				
		var ss = (type=="INT")? "#" : "&"
		//var sMask = ss;
		var nDec = Number(sFormat.substring(1, sFormat.length-1));
		if(isNaN(nDec))
		{
			if ("INT" == type)
				nDec = 12;
			else
				nDec = 512;
		}
		if(type=="TEXT" && nDec>=512)
			nDec = 512;				
		for(var n=0; n<nDec; n++)
			sMask += ss;
	}
	else if(type=="LONGTEXT")
	{
		sMask = strRepl("&", 1024);
	}
	if(!sMask)
		return "";
	return sMask;
}

function getVarsEval(sVar)
{
	return list;
}

function DpBaseDialog_eval(sExpr)
{
	if (typeof(ctrlLinker) != "undefined" && ctrlLinker != null)
	{
		ctrlLinker.updateData(true);
	}
	if (typeof(this.ctrlLinker) != "undefined")
	{
		list.ctrlLinker.updateData(true);
	}	
	this.saveExt(false);	
	
	if (sExpr.toLowerCase().startsWith("getx('") || sExpr.toLowerCase().startsWith('getx("'))
	{
		sExpr = sExpr.substring(6)
		sExpr = "EXT." + sExpr.substr(0,sExpr.length-2);
	}
	
	if (extPar && extPar.doc)
		return extPar.doc.eval(sExpr);
	if (extPar && extPar.dpObj)
		return extPar.dpObj.eval(sExpr);
	if (extPar && extPar.obj && objTypeOf(extPar.obj)== "DpDocRow")
		return extPar.obj.eval(sExpr);
	
	return 0;
}

function DpBaseDlg_buildDocRegAttrTab(oDoc)
{
	if(this.sMode=="MASS_EDIT")
		return;
	
	 
	var RegTab = null;
	if (oDoc)
	{
		RegTab = FORM.getControlComposite();
	}
	else 
	{
		RegTab = this.addTab(UR("Податк.реквіз.|Нал.реквиз."));
		oDoc = extPar.doc;
	}
	
	
	
	if (RegTab == null) return;
	
	RegTab.getLayout().numColumns = 10;
	var arrRegs = oDoc.getRegNums();

	// Выводим регистрацию попкупок
	var isHeader = false;
	for (var i = 0; i < arrRegs.length; i++)
	{
		oReg = arrRegs[i];
		var sVid = (strIn("P",oReg.getType())?"+":"-");
	
		if (sVid == "+")
		{
			if (!isHeader)
			{
				this.createNalReqHeader(RegTab, sVid);
				isHeader = true;
			}
			this.createNalReqRow(RegTab, oReg);
			this.fillReq(oReg, oDoc);
		}
	}

	// Выводим регистрацию продаж
	var isHeader = false;
	for (var i = 0; i < arrRegs.length; i++)
	{
		oReg = arrRegs[i];
		var sVid = (strIn("P",oReg.getType())?"+":"-");
		
		if (sVid == "-")
		{
			if (!isHeader)
			{
				this.createNalReqHeader(RegTab, sVid);
				isHeader = true;
			}
			this.createNalReqRow(RegTab, oReg);
			this.fillReq(oReg, oDoc);
		}
	}

}

function DpBaseDlg_createNalReqHeader(RegTab, sVid)
{
	var dlgBuilder = FORM.getDialogBuilder();
	var gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	var ctrl = dlgBuilder.addLabel(RegTab,"Журнал",false);
	ctrl.setLayoutData(gd);
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,UR("Под.накл.|Нал.накл."),false);
	ctrl.setLayoutData(gd);
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,"Номер",false);
	ctrl.setLayoutData(gd);
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,"Дата " + (sVid == "+"? "получ": ""),false);
	ctrl.setLayoutData(gd);

	if (sVid == "+")
	{
		gd = new Packages.org.eclipse.swt.layout.GridData();
		gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
		ctrl = dlgBuilder.addLabel(RegTab,"Дата выписки",false);
		ctrl.setLayoutData(gd);
	}
	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,"Тип (для реестра)",false);
	ctrl.setLayoutData(gd);
	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,UR("Форма cплати|Форма оплаты"),false);
	ctrl.setLayoutData(gd);
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,UR("Умова прод.|Условие прод."),false);
	ctrl.setLayoutData(gd);
/*	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,UR("Договір|Договор"),false);
	ctrl.setLayoutData(gd);
*/
	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	if (getRegPar("+","CODMNG")!=0 || getRegPar("-","CODMNG")!=0)
	{
		gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
		ctrl = dlgBuilder.addLabel(RegTab,"Менеджер",false);
		ctrl.setLayoutData(gd);
	}
	gd = new Packages.org.eclipse.swt.layout.GridData();
	if (getRegPar("+","CODZONE")!=0 || getRegPar("-","CODZONE")!=0)
	{
		gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
		ctrl = dlgBuilder.addLabel(RegTab,"Зона",false);
		ctrl.setLayoutData(gd);
	}
	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addLabel(RegTab,"Код причины",false);
	ctrl.setLayoutData(gd);
	
	if (sVid != "+")
	{
		gd.horizontalSpan = 2;
	}
	
	gd = new Packages.org.eclipse.swt.layout.GridData(); 
	gd.horizontalSpan = 10;
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
	ctrl = dlgBuilder.addHR(RegTab,gd,"");
}

function DpBaseDlg_fillReq(oReg, oDoc)
{
	var nReg = oReg.Num;
	var sVid = (strIn("P",oReg.getType())?"+":"-");
	var ctrl = document["ISNOV1_" + String(nReg)];	
	var isNov = oDoc.getRegAttr(nReg,"ISNOV1");
	if (typeof(isNov) == "string")
	{
		isNov = (isNov == "true");
	}
	if (typeof(isNov) == "number")
	{
		isNov = (isNov == SqlTrue);
	}	
	ctrl.setValue(isNov==false);
	
	ctrl = document["NK_NUM_" + String(nReg)];
	var obj = new Object();
	obj.nReg = nReg;
	obj.sVid = sVid;
	obj.nextNum = new Function("getNextNum('" + nReg + "','" + sVid + "')");
	
	ctrl.buttonHandler(obj,"nextNum");
	ctrl.setButton();
	if (this.sMode == "EDIT" || this.sMode == "VIEW")
		ctrl.setValue(oDoc.getRegAttr(nReg,"NK_NUM"));
	else
	{
		//obj.nextNum();
	}
	
	ctrl = document["NK_DAT_" + String(nReg)];
	if (this.sMode != "COPY")
		ctrl.setValue(oDoc.getRegAttr(nReg,"NK_DAT"));
	
	if (sVid=="+")
	{
		ctrl = document["VYP_DATE_" + String(nReg)];
		if (this.sMode != "COPY")
			ctrl.setValue(oDoc.getRegAttr(nReg,"VYP_DATE"));
	} 

	ctrl = document["OP_FORM_" + String(nReg)];
	ctrl.setValue(oDoc.getRegAttr(nReg,"OP_FORM"));
	ctrl = document["PR_COND_" + String(nReg)];
	ctrl.setValue(oDoc.getRegAttr(nReg,"PR_COND"));
	
	ctrl = document["VID_DOC_" + String(nReg)]
   	ctrl.setValue(oDoc.getRegAttr(nReg,"VID_DOC"));
	
	
/*	
//----------- dpCntrct
	ctrl = eval("GROUP_" + String(nReg));

	include("objects\\DpCntrct.js");
	var dogreg = getRegPar(sVid,"DOGREG");
	var forg = oDoc.getVar(oDoc.getAttr("FLDORG"));
	var oContr = new DpCntrct("0" + dogreg,dpDoc_getOrg,oDoc.getRegAttr(nReg,"IDCONTR"));
	oContr.linkCtrl(ctrl);
	ctrl.setData("dp",oContr);
	//----------------------------------
*/	
	
	ctrl = document["MNG_" + String(nReg)];
	var nMngCl = getRegPar(sVid,"CODMNG");
	if (nMngCl != 0)
	{
		include("objects\\DpCl.js");
		var oMngCl = new DpCl("0",nMngCl,oDoc.getRegAttr(nReg,"MNG"));
		oMngCl.linkCtrl(ctrl);
	}
	else
	{
		// Объекта нет
		//ctrl.setEnabled(false);
	}
	
	ctrl = document["ZONE_" + String(nReg)];
	var nZoneCl = getRegPar(sVid,"CODZONE");
	if (nZoneCl != 0)
	{
		include("objects\\DpCl.js");
		var oZoneCl = new DpCl("0",nZoneCl,oDoc.getRegAttr(nReg,"ZONE"));
		oZoneCl.linkCtrl(ctrl);
	}
	else
	{
		// Объекта нет
		//ctrl.setEnabled(false);
	}

	ctrl = document["TREASON_" + String(nReg)];
	include("objects\\DpCl.js");
	var oReasonCl = new DpCl("0",getPar("CODNNPRICHINY"),oDoc.getRegAttr(nReg,"TREASON"));
	oReasonCl.linkCtrl(ctrl);
}

function getNextNum(nReg,sVid)
{
	var nkNum = parseInt(getRegPar(sVid,"NGNKNUM"));
	nkNum += 1;
	var ctrl = document["NK_NUM_" + String(nReg)];
	nkNum = String(nkNum);
	ctrl.setValue(nkNum);
	Packages.org.eclipse.swt.widgets.Display
				.getDefault().asyncExec(function()
	{			
			setRegPar(sVid,"NGNKNUM",nkNum);   
   }
   );
	
}

function dpDoc_getOrg()
{
	if (typeof(ctrlLinker) != "undefined" && ctrlLinker != null)
	{
		ctrlLinker.updateData(true);
	}
	if (typeof(this.ctrlLinker) != "undefined")
	{
		list.ctrlLinker.updateData(true);
	}
	
	var forg = extPar.doc.getVar(extPar.doc.getAttr("FLDORG"));
	
	//fruckt
	//в некоторых документах понятия контрагент для договора нет (CP,CR)
	//так что меняем установленный моде для DpCntrct с "+" на "*"
	//иначе он требует установить код контрагента
	/*
	 * перенес в DpCntrct_zaval()
	 * в некоторых документах поле для договора стоит перед контрагентом
	 * и при срабатывании валидности вызывается getOrg() до попадания курсора в поле для выбора контрагента, т.е. в момент когда контрагент=0
	 * если при этом установить setMode("*"), будет вызываться насильный завал даже если выбор договора не обязателен...
	 * вобщем налажали так налажали...
	if (isEmpty(forg))
	{
		this.setMode("*");
	}
	*/
	
	return !forg? 0 : forg;
}

function DpBaseDlg_createNalReqRow(RegTab,oReg)
{
	var nReg = oReg.Num;
	var sVid = (strIn("P",oReg.getType())?"+":"-");

	
	var dlgBuilder = FORM.getDialogBuilder();
	var ctrl = dlgBuilder.addLabel(RegTab,String(nReg),false);
	var gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl.setLayoutData(gd);
	
	gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.CENTER;
	ctrl = dlgBuilder.addCheckBox(RegTab,null,gd,"ISNOV1_" + nReg);
	
	ctrl = dlgBuilder.addTextField(RegTab,"NK_NUM_" + nReg,null,100);
	//ctrl.setMask("###");
//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"NK_NUM"));
	
	ctrl = dlgBuilder.addDate(RegTab,"NK_DAT_" + nReg,null);
//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"NK_DAT"));
	
	if (sVid=="+")
	{
		ctrl = dlgBuilder.addDate(RegTab,"VYP_DATE_" + nReg,null);
	}
	
	/*
	var vidValues = new Array();
	var vidTexts = new Array();
	
	var codnaklvid = getPar("CODNAKLVID");
	if(codnaklvid)
	{
		var vidTbl = OpenTable("select * from ^LISTCL where FCL="+ codnaklvid +" order by FCOD");
		for(; !vidTbl.isEOF(); vidTbl.moveNext())
		{
			var scod = vidTbl.getValue("FTCOD");
			vidValues[vidValues.length] = scod;
			vidTexts[vidTexts.length] = scod +" - "+ vidTbl.getValue("FTXT");
		}
		vidTbl.close();
	}
	else
	{
		if (sVid=="+")
		{
			vidValues = ["ПН", "ПНП", "ПНЕ", "ПНУ", "ПНПУ", "ПНЕУ", "РК", "РКП", "РКЕ", "ВМД", "МДП", "МДЕ", "ЧК", "ТК", "ГР", "ПЗ", "ПО", "ЗП", "НП", "БО"];
			vidTexts = [
				"ПН - податкова накладна"
				, "ПНП - податкова накладна (паперовий варіант)"
				, "ПНЕ - податкова накладна (електронний варіант)"
				, "ПНУ - податкова накладна уточнююча"
				, "ПНПУ - податкова накладна уточнююча (паперовий варіант)"
				, "ПНЕУ - податкова накладна уточнююча (електронний варіант)"
				, "РК - розрах.кориг.до ПН"
				, "РКП - розрах.кориг.до ПН (паперовий варіант)"
				, "РКЕ - розрах.кориг.до ПН (електронний варіант)"
				, "ВМД - вантаж.митна декл."
				, "МДП - митна декл. (паперовий варіант)"
				, "МДЕ - митна декл. (електронний варіант)"
				, "ЧК - товарний(кас.)чек"
				, "ТК - транспорт.квиток"
				, "ГР - готельний рахунок"
				, "ПЗ - за посл.зв’язку"
				, "ПО - за прилад.обліку"
				, "ЗП - заява платника"
				, "НП - неплатниик"
				, "БО - документ бухобліку"
				];
		}
		else if (sVid=="-")
		{
			vidValues = ["ПН", "ПНП", "ПНЕ", "ПНУ", "ПНПУ", "ПНЕУ", "РК", "РКП", "РКЕ", "ВМД", "МДП", "МДЕ", "ПП", "ЗЦ", "БО"];
			vidTexts = [
				"ПН - податкова накладна"
				, "ПНП - податкова накладна (паперовий варіант)"
				, "ПНЕ - податкова накладна (електронний варіант)"
				, "ПНУ - податкова накладна уточнююча"
				, "ПНПУ - податкова накладна уточнююча (паперовий варіант)"
				, "ПНЕУ - податкова накладна уточнююча (електронний варіант)"
				, "РК - розрах.кориг.до ПН"
				, "РКП - розрах.кориг.до ПН (паперовий варіант)"
				, "РКЕ - розрах.кориг.до ПН (електронний варіант)"
				, "ВМД - вантаж.митна декл."
				, "МДП - митна декл. (паперовий варіант)"
				, "МДЕ - митна декл. (електронний варіант)"
				, "ПП - за щоден.підсумками"
				, "ЗЦ - перевищ.звич.ціни"
				, "БО - документ бухобліку"
				];
		}
		
		ctrl = dlgBuilder.addComboBox(RegTab,vidValues,vidTexts,null,70,"VID_DOC_" + nReg);
		//ctrl = dlgBuilder.addTextField(RegTab,"VID_DOC_" + nReg,null, 70);
	}
	*/
	ctrl = dlgBuilder.addTextField(RegTab, "VID_DOC_" + nReg, null, 100);
	setButton(ctrl, this, "vidNaklZaval");
		
	var arr = getPar("rgopfrms").split(",");
	ctrl = dlgBuilder.addComboBox(RegTab,arr,arr,null,50,"OP_FORM_" + nReg);
//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"OP_FORM"));
	
	ctrl = dlgBuilder.addTextField(RegTab,"PR_COND_" + nReg,null,90);
//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"PR_COND"));
	
//-	ctrl = dlgBuilder.addTextField(RegTab,"GROUP_" + nReg,null,70);
	
	if (getRegPar(sVid,"CODMNG")!=0)
	{
		ctrl = dlgBuilder.addTextField(RegTab,"MNG_" + nReg,null,70);
	}
//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"MNG"));
	
	if (getRegPar(sVid,"CODZONE")!=0)
	{
		ctrl = dlgBuilder.addTextField(RegTab,"ZONE_" + nReg,null,50);
		//-	ctrl.setValue(extPar.doc.getRegAttr(nReg,"ZONE"));
	}
	
	ctrl = dlgBuilder.addTextField(RegTab,"TREASON_" + nReg,null,50);

	
	if (sVid != "+")
	{	
		ctrl.getCtrl().getParent().getLayoutData().horizontalSpan = 2;
	}
}

function DpBaseDlg_vidNaklZaval(ctrl)
{
	if(!this.objNaklvid)
	{
		var codnaklvid = getPar("CODNAKLVID");
		if(codnaklvid)
		{
			var oSnap = getSnap("select FVID from ^CLCL where FCOD="+ Number(codnaklvid));
			if(!oSnap)
				codnaklvid = 0;
		}
		if(!codnaklvid)
		{
			var oSnap = getSnap("select FCOD from ^CLCL where FVID='naklvid'");
			if(oSnap)
			{
				codnaklvid = oSnap[0];
				setPar("CODNAKLVID", codnaklvid);
			}
			else
			{
				var clSnap = getSnap("select max(FCOD) from ^CLCL");
				if(clSnap)
				{
					codnaklvid = Number(clSnap[0])+1;
					setPar("CODNAKLVID", codnaklvid);
					var m	= new Object();
					m.FTXT	= UR("Види податкових накладних|Виды налоговых накладных");
					m.FCOD	= codnaklvid;
					m.FVID	= "naklvid";
					m.FWID	= GetUID();
					updateTable("^CLCL", m, true);
				}
			}
		}
		if(codnaklvid)
			this.objNaklvid = new DpCl("0", Number(codnaklvid), 0);
	}
	if(this.objNaklvid)
	{
		var par = this.objNaklvid.zaval();
		if(!par.escape)
		{
			ctrl.setText(this.objNaklvid.getTCod());
		}
	}
}

function DpBaseDlg_buildDocLabelsTabs()
{
	include ("Objects/DpLabel.js")
	include ("objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	var dlgBuilder = FORM.getDialogBuilder();
	var arrLbl = extPar.doc.getLabelClasses();
	for (var i = 0; i < arrLbl.length; i++)
	{
		var oLbl = arrLbl[i];
		
		var name = oLbl.getName();
		var nCl = oLbl.getNomCl();
		var lblTab = this.addTab(name);
		var lblComp = FORM.addScrolledComposite(lblTab);
		var tbl = OpenTable ("select fcod , ftxt from ^listcl where fcl = " + nCl);
		
		while (!tbl.isEOF())
		{
			var xmlCheck = xmlDom.createElement("CheckBox");
			var ctrlId = "DOCLBL" + oLbl.getID() + String(Number(tbl.getValue("fcod")));
			xmlCheck.setAttribute("ID", ctrlId);
			xmlCheck.setAttribute("text", tbl.getValue("ftxt"));
			
			//var gd = new Packages.org.eclipse.swt.layout.GridData();
			//FORM.AddCheckBox(txt, ctrlId);
			var ctrl = dlgBuilder.addCheckBox(lblComp, xmlCheck.xmlNode);
			
			
			tbl.moveNext();
		}
		lblComp.pack();
		tbl.close();
	}
	
	var lblValues = extPar.doc.getAllLabels();
	for (var i = 0; i < lblValues.length; i++)
	{
		var lblValue = lblValues[i];
		var ctrl = "DOCLBL" + String(lblValue.getTypeName()) + String(Number(lblValue.getValue()))
		if (document[ctrl])
			document[ctrl].checked = true;
	}
}

function DpBaseDlg_saveDocLabels()
{
	include ("Objects/DpLabel.js")	
	var xmlDom = new DpXMLDOMDocument();
	var dlgBuilder = FORM.getDialogBuilder();
	extPar.doc.removeAllLabels();
	var arrLbl = extPar.doc.getLabelClasses();
	for (var i = 0; i < arrLbl.length; i++)
	{
		var oLbl = arrLbl[i];
		
		var name = oLbl.getName();
		var nCl = oLbl.getNomCl();
		var tbl = OpenTable ("select fcod , ftxt from ^listcl where fcl = " + nCl);
		
		while (!tbl.isEOF())
		{
			var ctrlId = "DOCLBL" + oLbl.getID() + String(Number(tbl.getValue("fcod")));			
			if (document[ctrlId] && document[ctrlId].checked)
			{
				extPar.doc.addLabel(oLbl.getID(), Number(tbl.getValue("fcod")));
			}
			
			tbl.moveNext();
		}
		
		tbl.close();
	}

}



function DpBaseDlg_buildObjExtTab(isEditOnlyExt)
{
	if (!isEditOnlyExt)
		isEditOnlyExt = false;	
	//var rExtTab = this.addTab(UR("Розширення|Расширения"));
	//var ExtTab = FORM.addScrolledComposite(rExtTab);
	
	var extInfoMap;
	if (this.isDoc)
		extInfoMap = extPar.doc.getExtInfo();
	else
		extInfoMap = extPar.dpObj.getExtInfo();
	/*for (var extLbl in extInfoMap)
	{
		this.addCtrl(ExtTab,extInfoMap[extLbl],"#");
	}*/	
	var i = 1;
	this.arrSort = new Array();
	for (var extLbl in extInfoMap)
	{
		var ext = extInfoMap[extLbl];
		this.arrSort[i++] = ext;
	}
	this.arrSort.sort(sortExt);	
	//vlad 27.11.11 теперь расширения счет-ан.3 рисуем одной строкой,
	//поэтому в цикле перебираем не все расширения ()
	//for (var extPos in this.arrSort)
	for (this.extPos = 0; this.extPos < this.arrSort.length; this.extPos++)
	{
		if(this.arrSort[this.extPos])
		{
			if (this.arrSort[this.extPos].E_isFirstPage || isEditOnlyExt)
			{
				this.addCtrl(this.getExtPanel(), this.arrSort[this.extPos], "#");				
			}
			else
				this.addCtrl(this.getExtTab(), this.arrSort[this.extPos], "#");
		}
	}
	
	
	if (this.extTab != null)
	{
		var e;
		try
		{
			var shell = this.extTab.getShell();
			if((shell.getStyle() & 16) == 0)
			{
				var shellSize = shell.getSize();
				var shellHeigth = shell.computeSize(-1, -1).y;
				
				//alert(p.y);
				var extHeight = this.extTab.getSize().y;
				var cntrHeight = FORM.ctrlComp.computeSize(-1, -1).y;
				
				var delta = extHeight - (cntrHeight - 15);		
				if (delta > 0 && extHeight < 400)
				{			
					shell.setMinimumSize(10, shellHeigth + delta);
					
				}			
			}
		}
		catch(e)
		{
			
		}
	}
	
	if (false && this.extPanel != null)
	{
		this.extPanel.layout(true, true);
		this.extPanel.getParent().layout(true, true);
		this.extPanel.getParent().getParent().layout(true, true);
		//this.extPanel.getParent().pack();
	}

	//fruckt
	//при отрисовке расширений на первой странице - контрол рисовался где попало
	//теперь рисуется внизу формы - но необходимо обновление родителя
	if (this.extPanel != null)
	{
		//SAM 01.07.2011
		//так как бы лучше, и работает (пока!) корректно и в справочниках, и в документах
		var e;
		try
		{
			var oShell = FORM.getShell();
			var nSize = oShell.getSize();
			oShell.pack();
			oShell.setSize(nSize);
		}
		catch (e)
		{
			//alert("DpBaseDlg_buildObjExtTab(): "+e);
		}
	}
}

function DpBaseDlg_getExtTab()
{
	if (this.extTab != null)
		return this.extTab;
	var rExtTab = this.addTab(UR("Розширення|Расширения"));
	this.extTab = FORM.addScrolledComposite(rExtTab);
	return this.extTab;
	
}

function DpBaseDlg_getExtPanel()
{
	if (this.extPanel != null)
		return this.extPanel;
	
	var crtlComp = FORM.getControlComposite();
	var numCol = 2;
	var e;
	try
	{
		numCol = Number(crtlComp.getLayout().numColumns);
		if (isNaN(numCol))
			numCol = 2;
			
	}
	catch(e)
	{
	}
	
	var dlgBuilder = FORM.getDialogBuilder();
	var gd = new Packages.org.eclipse.swt.layout.GridData();
	//gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
	//gd.grabExcessHorizontalSpace = true;
	gd.horizontalSpan = numCol; 
	
	
	this.extPanel = dlgBuilder.addComposite(crtlComp, "EXTPANEL",gd);
	this.extPanel.setLayoutData(gd);
	var gl = new Packages.org.eclipse.swt.layout.GridLayout(2, false);
	//gl.verticalSpacing = 0;
    //gl.horizontalSpacing = 0; 
    gl.marginWidth = 0;
    gl.marginHeight = 0;
	this.extPanel.setLayout(gl);
	return this.extPanel;
}



function sortExt(e1, e2)
{
	if(Number(e1.E_Pos) < Number(e2.E_Pos))
		return -1;
	else
		return 1;
}

function DpBaseDlg_buildExtTab()
{
	//var rExtTab = this.addTab(UR("Розширення|Расширения"));
	//var ExtTab = FORM.addScrolledComposite(rExtTab);
	
	
	for(var iTie = 0; iTie < extPar.ExtAliases.length; iTie++)
	{
		var alias = extPar.ExtAliases[iTie];
		var etbl = extPar.tblSrc.GetTie(alias);
		var nCols = etbl.fieldCount();
		for(var iCol = 1; iCol < nCols + 1; iCol++)
		{
			var FI = etbl.getFieldInfo(iCol);
			//this.addCtrl(ExtTab,FI,alias);
			
			if (FI.E_isFirstPage)
			{
				this.addCtrl(this.getExtPanel(), FI,alias);				
			}
			else
				this.addCtrl(this.getExtTab(), FI,alias);
			
		}
	}
}



function DpBaseDlg_addTab(sTxt)
{
	var nTab = 1;
	var tabFolder = FORM.getTabFolder();
	if(tabFolder)
		nTab = tabFolder.getItemCount();
	if(!sTxt)
		sTxt = "Стр."+ nTab;
	var tab = FORM.addTab(sTxt);
	this.arrTab[nTab] = tab;
	return tab;
}

function DpBaseDlg_validateAll()
{
	//проверяем права на добавление документов
	if(this.sMode == "ADD" && typeof ctrlLinker != "undefined" && extPar.doc)
	{
		var datCtrl = ctrlLinker.arrCtrl["HDAT"];
		if (typeof datCtrl != "undefined" && (typeOf(datCtrl) == "DpDate" || typeOf(datCtrl)=="DpDateTime"))
		{
			var acc = String(getAccess(extPar.doc.getVar("HDOC"), extPar.doc.getVar("HNOP")));
			var accd = String(getAccessForDate(this.getValue(datCtrl)));
			//trace("access on doc >> "+acc);
			//trace("access on date >> "+accd);
			if(acc.indexOf("A")==-1 || accd.indexOf("A")==-1)
			{
				var strError = ru("Недостаточно прав для добавления документа на дату "
					, "Недостатньо прав для додавання документа на дату ")+format("dd.mm.yyyy", this.getValue(datCtrl));
				setFocus(datCtrl);
				WAIT(strError);
				return false;
			}
		}
	}
	if(typeof ctrlLinker != "undefined" && extPar.dpObj && extPar.dpObj.instanceOf("CL1"))
	{
		var codCtrl = ctrlLinker.arrCtrl["HCOD"];
		
		//if (typeof codCtrl == "undefined" || typeOf(codCtrl) != "DpTextEx")
		//	codCtrl = ctrlLinker.arrCtrl["HNOM"];
		if (typeof codCtrl != "undefined" && typeOf(codCtrl) == "DpTextEx")
		{
			var bOK,s, ts;
			s = "SELECT FCOD FROM ^listcl "		
				+" WHERE FCOD=" + codCtrl.value + " and FCL=" + extPar.dpObj.getVar("HCL")
				+" and fwid <> "+ extPar.dpObj.getID();
			ts = getSnap(s);
			if(ts)
			{
				/*
				var strError = ru("Запись с таким кодом уже существует"
					, "Запис із таким кодом вже існує");
				setFocus(codCtrl);
				WAIT(strError);
				return false;
				*/
				// Net 22.12.2011  молча генерируем свободный/максимальный
				if (inList(this.sMode, "ADD", "COPY"))
				{
					ctrlLinker.arrCtrl["HCOD"].value = getNextCod(extPar.dpObj.getVar("HCL"));
				}
			}
		}
	}
	
	var ctrls = new Array();
	if (typeof(FORM.getControls) == "function")
	{
		ctrls = FORM.getControls(); 
	}
	for (var i = 0; i < ctrls.length; i++)
	{
		var oCtrl = null;
		var e;
		try
		{
			oCtrl = eval(String(ctrls[i]));
		}
		catch(e)
		{
		}	
		
		if (typeof(oCtrl) == "undefined" || !oCtrl)
			continue;
		
		//fruckt
		if (objTypeOf(oCtrl) == "DpCheck")
		{
			var check = oCtrl.getCtrl();
			if (typeof(check.isDisposed) != "undefined")
				if (check.isDisposed())
					continue;
		}
		else if (typeof(oCtrl.isDisposed) != "undefined")
		{
			if (oCtrl.isDisposed())
				continue;
		}
		
		if (typeof(oCtrl.isEnabled) != "undefined")
		{
			if (!oCtrl.isEnabled())
				continue;
		}
		
		if (this.validOnlyVisibleCtrls)
		{
			if (typeof(oCtrl.isVisible) != "undefined")
			{
				if (!oCtrl.isVisible())
					continue;
			}
		}
		
		if (runValid(oCtrl) == false)
		{
			setFocus(oCtrl);			
			this.bSaving = false;
			return false;
		}		
	}
	return true;
}

//функция получения следующего кода по таблице (^cl)
function getNextCod(nCl)
{
	var minCod = 1;
	var maxCod = 0;
	var isAddMin = false;
	var cl = nCl;
	var oSnap = getSnap("select FNMIN, FNMAX, Fisaddmin from ^CLCL where FCOD="+ cl);
	if(oSnap)
	{
		minCod = Number(oSnap[0]);
		maxCod = Number(oSnap[1]);
		isAddMin = toScrObj(oSnap[2]);
		if(minCod<=0)
			minCod = 1;
	}
		
	var s, t, ret
	//ищем по минимальному или максимальному коду
	if(isAddMin)
	{
		s = " select min(r.FCOD) as FMIN "
			+" from ^CLRELCLCL r "
			+" where 1 = 1 "
				+" and r.FCL="+ cl 
				+" and r.FCOD < "+(Math.pow(2, 31)-1)	// Net 22.12.2011  если в таблице уже есть 2147483647 (а такое может случиться из-за кривых рук),
														// чтобы не ругалось
				+" and FCOD>="+ minCod +(maxCod>0?" and FCOD<="+ maxCod:"") 
				+" and not exists (select * from ^CLRELCLCL r2 where r2.FCL="+ cl +" and r2.FCOD=(r.FCOD+1))"
	}
	else
	{
		s = "SELECT MAX(b.FCOD) AS FMAX"		
			+ " FROM ^CL a"
			+ " INNER JOIN ^CLRELCLCL b ON a.FWID=b.FWID_CL"
			+ " WHERE b.Fcl=" + nCl
	}

	var oSnap = getSnap(s)
	ret = minCod;
	if(oSnap!=null)
	{
		if(Number(oSnap[0])>=minCod)
			ret = oSnap[0]+1;
	}
	if(maxCod>0 && Number(ret)>maxCod)
	{
		var oSnap = getSnap("select FCOD from ^CLRELCLCL where FCL="+ cl +" and FCOD="+ minCod);
		if(oSnap && oSnap[0])
		{
			oSnap = getSnap("select min(r.FCOD) as FMIN from ^CLRELCLCL r"
							+" where r.FCL="+ cl 
								+" and FCOD>="+ minCod +(maxCod>0?" and FCOD<="+ maxCod:"") 
								+" and not exists (select * from ^CLRELCLCL r2 where r2.FCL="+ cl +" and r2.FCOD=(r.FCOD+1))"
							);
			if(oSnap && Number(oSnap[0]))
			{
				ret = oSnap[0]+1;
			}
			else
			{
				var sMsg = UR("Нумерація у довіднику досягла максимального значення!"
							+"|Нумерация в справочнике достигла максимального значения!"
							);
				alert(sMsg);
			}
		}
		else
		{
			ret = minCod;
		}		
	}
	return ret;
}

function DpBaseDlg_massUpdate(arrID)
{
	var obj = extPar.doc;
	if(this.isObj)
		obj = extPar.dpObj;
		
	if(!arrID && extPar)
		arrID = extPar.arrID;
	if(!arrID)
		return false;
	
	var sMsg = UR("Відмічено записів для редагування - "+ arrID.length +"|Отмечено записей для редактирования - "+ arrID.length);
	var sMod = "";
	var arrCtrl = FORM.getControls();
	for (var i = 0; i < arrCtrl.length; i++)
	{
		var sCtrlID = String(arrCtrl[i]); 
		var oCtrl = eval(sCtrlID);
		if (typeof(oCtrl)=="undefined" || !oCtrl)
			continue;		
		if (typeof(oCtrl.isDisposed)!="undefined" && oCtrl.isDisposed())
			continue;
		if (typeof(oCtrl.isEnabled)!="undefined" && !oCtrl.isEnabled())
			continue;
		if (typeof(oCtrl.getValue)=="undefined")
			continue;
		if(typeOf(oCtrl)=="DpGrid")
			continue;
		var oVal = this.getValue(oCtrl);
		var sVal = String(oVal).trim();				
		if(typeOf(oCtrl)=="DpTextEx")
		{
		 	if(sVal==this.nullTxt)
				continue;
			var str = String(oCtrl.value).trim();
			if(str.startsWith("="))
				sVal = str.substring(1);
		}
		if(oVal==null || sVal==null || sVal=="null")
			continue;
		if(typeOf(oCtrl)=="DpDate" || typeOf(oCtrl)=="DpDateTime")
		{
			sVal = String(oCtrl.getCtrl().getText()).trim();
			if(sVal.indexOf("пуст")!=-1)
				continue;
		}
		if(sVal=="")
			sVal = "''";					
		sMod += "\n"+ sCtrlID +" - "+ sVal;
	}
	if(sMod!="")
		sMsg += "\n"+ UR("Внесені зміни:|Внесенные изменения:") + sMod;
	sMsg += "\n"+ UR("Зберегти зміни для відмічених записів?|Сохранить изменения для отмеченных записей?");
	if(!confirm(sMsg))
		return false;
	
	var monitor = getProgressMonitor();
	monitor.beginTask(UR("Масове редагування...|Массовое редактирование..."), arrID.length);
	monitor.worked(1);	
	
	var bFill = false;
	var m = new Object();
	var oFld = new Object(); 
	if(typeof(fillObject) == "function")
	{
		this.fillObject = fillObject;						
		this.fillObject(m);		
		for(var fld in m)
		{
			var oVal = m[fld];
			var sVal = String(oVal).trim();
			if(String(fld).toUpperCase()=="FWID")
				continue;			
			if(oVal==null || sVal==this.nullTxt || sVal=="null")
				continue;			
			oFld[fld] = oVal;
			trace(fld +" > "+ sVal)
			bFill = true;
		}					
	}
	
	for(var i=0; i<arrID.length; i++)
	{		
		monitor.worked(1);
		var rowID = arrID[i];
		this.sFWID = rowID;
		//trace("\n>>> DpBaseDlg_massUpdate: "+ rowID);
		if(obj)
		{
			var extTbl = obj.extTbl;
			var hasExt = obj.hasExt();
			//obj.clear();			
			//obj.extTbl = null;						
			if(!obj.loadByID(rowID))
				continue;
			obj.extTbl = extTbl;
			bFill = this.fillMassEditObject(obj);			
			if(bFill)
			{
				if(typeof NOP_COMBO!="undefined")
				{
					var nop = NOP_COMBO.value;
					if(Number(nop))
					{
						var oldNop = Number(obj.getVar("HOP"));
						obj.oReg = null;
						obj.delRegistration();
						if(Number(nop)!=oldNop)
						{	
							//ExecuteSQL("DELETE FROM ^SCHET WHERE FID_DOC=" + sqlTo(obj.getID()));
						}
						obj.setVar("HOP", java.lang.Integer(nop));
						obj.jDoc.setVar("HOP", java.lang.Integer(nop));
						//obj.extTbl = null;
					}
				}
				//extPar.doc = obj;
				//if(this.isDoc && obj.getRegNums().length > 0)
				//	this.saveDocRegAttrs();
				obj.save(false, "EDIT", true);				
				if(obj.storeExt)
					obj.storeExt();
				else if(hasExt)
					obj.saveExtToDB();								
			}
		}
		else
		{
			oFld.FWID = rowID;		
			if(bFill)
				UpdateTable(extPar.m_pTable.getTableName(), oFld, false);
			
			for (var ctrl in this.extCtrlMap)
			{
				var alias = allt(ctrl.substr(0,ctrl.indexOf("_")));
				var label = allt(ctrl.substr(ctrl.indexOf("_") + 1));
				if (alias.substr(0,1) == "X" && alias.length == 1)
					alias = "#";
				if (alias == "" || label == "")
					continue;
				var oVal = this.getValue(this.extCtrlMap[ctrl]);
				var sVal = String(oVal).trim();
				if(oVal==null || sVal==this.nullTxt || sVal=="null")
					continue;				
				var etable = extPar.tblSrc.GetTie(alias);
				if (etable == null)
					continue;						
				etable.setValue(Number(this.sFWID), label, oVal);
			}
		}		
	}
	
	if(obj)
	{
		if(obj.extTbl)
			obj.extTbl.close();
		if(obj.extTbl0)
			obj.extTbl0.close();
	}
	
	monitor.done();
	return true;
}

function DpBaseDlg_fillMassEditObject(obj)
{
	var bFill = false;
	var nullRGB = lpProxy.getDpAPI().rgb(0xFFFDDD);
	var ctrlLinker = null;
	if(obj.getCtrlLinker)
		ctrlLinker = obj.getCtrlLinker();
		
	var arrCtrl = FORM.getControls();
	for (var i = 0; i < arrCtrl.length; i++)
	{
		var sCtrlID = String(arrCtrl[i]); 
		var oCtrl = eval(sCtrlID);
		if (typeof(oCtrl)=="undefined" || !oCtrl)
			continue;		
		if (typeof(oCtrl.isDisposed)!="undefined" && oCtrl.isDisposed())
			continue;
		if (typeof(oCtrl.isEnabled)!="undefined" && !oCtrl.isEnabled())
			continue;
		if (typeof(oCtrl.getValue)=="undefined")
			continue;
		if(typeOf(oCtrl)=="DpGrid")
		{
			if(oCtrl.getTable())
				oCtrl.getTable().close();
			continue;
		}
		var oVal = this.getValue(oCtrl);
		var sVal = String(oVal).trim();				
		if(typeOf(oCtrl)=="DpTextEx" && sVal==this.nullTxt)
			continue;
		if(oVal==null || sVal==null || sVal=="null")
			continue;
		if(typeOf(oCtrl)=="DpDate" || typeOf(oCtrl)=="DpDateTime")
		{
			sVal = String(oCtrl.getCtrl().getText()).trim();
			if(sVal.indexOf("пуст")!=-1)
				continue;
		}		
		
		if(ctrlLinker && obj.setVar)
		{	
			var sVar = ctrlLinker.arrVar[sCtrlID];
			//trace("\n>>> "+ sCtrlID +" > "+ sVar);			
			if (sVar)
			{
				if(ctrlLinker.arrCL && ctrlLinker.arrCL[sVar])
				{
					var clCod = ctrlLinker.arrCL[sVar].getCod();
					if(clCod)
						oVal = clCod;
				}
				//trace(">>> "+ sCtrlID +" > "+ sVar +" - "+ oVal);	
				obj.setVar(sVar, oVal);
			}		
		}
		
		if(sCtrlID.indexOf("X_")!=-1 && obj.setExt)
		{
			var alias = allt(sCtrlID.substr(0, sCtrlID.indexOf("_")));
			var label = allt(sCtrlID.substr(sCtrlID.indexOf("_") + 1));
			if (alias.substr(0,1)=="X" && alias.length==1)
				alias = "#";
			oCtrl = this.extCtrlMap[sCtrlID];
			if(oCtrl)
				oVal = this.getValue(oCtrl);
			if (alias!="" && label!="")
				obj.setExt(label, oVal);
		}
		//trace(">>> "+ sCtrlID +" > "+ oVal);		
		bFill = true;
	}	
	return bFill;
}

function DpBaseDlg_getValue(oCtrl)
{
	if(!oCtrl)
		return null;
		
	if(this.sMode=="MASS_EDIT" && oCtrl.getCtrl)
	{
		var nullRGB = lpProxy.getDpAPI().rgb(0xFFFDDD);
		var rgb = oCtrl.getCtrl().getBackground().getRGB();
		if(rgb.equals(nullRGB))
			return null;
			
		if(typeOf(oCtrl)=="DpCheck")
		{
			if(oCtrl.getCtrl().getGrayed())
				return null;
		}
	}
	
	if(oCtrl.getValue)
	{
		var sVal = String(oCtrl.getValue()).trim();
		if(sVal.startsWith("="))
		{
			var sExpr = sVal.substring(1);
			var oVal = null;
			if(extPar && extPar.dpObj)
				oVal = extPar.dpObj.eval(sExpr);
			if(extPar && extPar.doc)
				oVal = extPar.doc.eval(sExpr);
			return oVal;
		}
	}
	
	if(oCtrl.getData)
	{
		//trace(oCtrl.getData("ID") +" > "+ oCtrl.getData("DPOBJ"))
		var dpObj = oCtrl.getData("DPOBJ")
		if(dpObj && dpObj.getCod)
		{
			var nCod = Number(dpObj.getCod());
			if(nCod)
				return nCod;
			return Number(oCtrl.value);
		}
		
		var sType = oCtrl.getData("TYPE");
		if(sType)
		{
			sType = String(sType).toLowerCase();
			if(sType=="number")
				return Number(oCtrl.value);
		}
	}
	
	if(typeOf(oCtrl)=="DpCheck")
	{
		return oCtrl.checked;
	}
		
	return oCtrl.getValue();
}

function DpBaseDlg_save()
{		
	this.isAppplyClick = false;
	if(this.sMode=="MASS_EDIT")
	{
		if(!this.massUpdate(extPar.arrID))
			return false;
		if (extPar)
			extPar.escape = false;	
		this.exit();		
		return true;
	}
	
	var ret = this.applyChanges(false);
	if (!ret)
		return false;
	this.exit();
		
	return true;	
}

function DpBaseDlg_apply()
{		
	var ret = this.applyChanges(true);
	if (!ret)
		return false;
	if (this.isDoc && extPar.doc)
		 extPar.doc.save(false,(extPar && extPar.apply)? "EDIT" : extPar.sMode);	
	if (extPar)
		extPar.apply = true;	
	
	return true;	
}




function DpBaseDlg_applyChanges(isApply)
{		
	// вешаем валидацию на счет в строках документов при сохранении
	if (typeof(nk) != "undefined" && !nk.validSc())
	{
		return false;
	}
	
	if (this.isDoc && extPar.bWorkDate && extPar.eWorkDate)
	{
		var dateCtrl = typeof(HDAT)=="object"? HDAT
			: typeof(FDOC_DAT)=="object"? FDOC_DAT
			: null;
		if (dateCtrl != null)
		{
			if (differ(toScrObj(dateCtrl.value),extPar.bWorkDate)<0 || 
				differ(toScrObj(dateCtrl.value),extPar.eWorkDate)>0)
			{
				if (!confirm( ru("Дата за пределами рабочего периода"+ "\nВы уверены, что так надо?",
						"Дата за межами робочого перiоду"+ "\nВи впевненi, що так треба?")))
				{
					return false;
				}
			}
		}
	}
		
	this.isAppplyClick = true;
	this.bSaving = true;
	//alert(HINVN.isEnabled())
	if (typeof (onPreviosSave) == "function")
	{
		this.onPreviosSave = onPreviosSave;
		this.onPreviosSave(isApply);
	}
	
	var bRet = true;
	
	softInvalid = false;
	
	var valid = this.validateAll();
	
	softInvalid = true;
	
	if (!valid)
	{
		this.isAppplyClick = false;
		return false;
	}
	
	if(lpProxy.isTest() && lpProxy.getTest().isWrite())
	{
		lpProxy.getTest().saveParam(FORM);		
	}
	
	if (typeof(extPar) != "undefined" && extPar 
			&& typeof(extPar.ret) == "object")
	{
			for (var i in extPar.ret)
			{
				if (typeof(document[i]) == "object"
					&& typeof(document[i].value) != "undefined")
				{
					extPar.ret[i] = document[i].value;	
				}
			}
	}
	
	handleEvent("beforeDialogSave", this);
	
	if(extPar && extPar.dpObj)
	{
		var nCod = Number(extPar.dpObj.getVar("HCOD"));
		if(extPar.dpObj.getCtrlLinker)
		{
			var codCtrl = extPar.dpObj.getCtrlLinker().arrCtrl["HCOD"];
			if(codCtrl)
				nCod = Number(codCtrl.value);
		}
		var minCod = extPar.dpObj.minCod;
		var maxCod = extPar.dpObj.maxCod;
		if((minCod>0 && nCod<minCod) || (maxCod>0 && nCod>maxCod))
		{
			var sMsg = UR("Код запису виходить за рамки допустимого діапазону!|Код записи выходит за рамки допустимого диапазона!");
			alert(sMsg);
			return false;
		}
	}
	
	if(this.onSave)
	{
		bRet = this.onSave(isApply);
	}	
	else if (typeof(fillObject) == "function")
	{
		this.fillObject = fillObject;
		var m = new Object();
		if(!m.Fwid && !m.FWID)
			m.FWID = this.sFWID;
		bRet = this.fillObject(m);
		if (!(bRet===false))
			UpdateTable(extPar.m_pTable.getTableName() ,m);
	}
	else if (this.controlsLinker != null && this.controlsLinker.isTable)
	{
		this.fillObject = this.stdFillObject;
		var m = new Object();
		if(!m.Fwid && !m.FWID)
			m.FWID = this.sFWID;		
		this.controlsLinker.toObject(m);
		UpdateTable(extPar.m_pTable.getTableName() ,m);
		
	}
	else if(this.controlsLinker != null)
	{
		this.controlsLinker.toVars();
	}
	
	if ((extPar && extPar.ExtAliases && extPar.ExtAliases.length > 0)
		|| (this.isDoc && extPar.doc.hasExt())
		|| (this.isObj && extPar.dpObj.hasExt()))
		this.saveExt();

	if (this.isDoc && extPar.doc.getRegNums().length > 0)
		this.saveDocRegAttrs();
	
	if (this.isDoc && extPar.doc && objTypeOf(extPar.doc)== "DpDoc")
		this.saveDocLabels();
	
	this.bSaving = false;
	if(bRet===false)
	{
		this.isAppplyClick = false;
		return false;
	}
	if (extPar)
		extPar.escape = false;
	
	if (typeof (onAfterSave) == "function")
	{
		this.onAfterSave = onAfterSave;
		this.onAfterSave();
	}
	
	handleEvent("afterDialogSave", this);
	
	if (extPar)
	{
		var oDoc = extPar.doc;
		if(!oDoc && extPar.obj)
			oDoc = extPar.obj;
		if (typeof(HID_DOG)=="object")
		{
			if (typeof this.oCntr.getID() == "number")
				oDoc.setVar("HID_DOG",this.oCntr.getID());
			else 
				oDoc.setVar("HID_DOG",0);
		}
	}
	if(extPar && extPar.doc)
	{
		if(this.oMyOrg)
			extPar.doc.setVar("HORG0", this.oMyOrg.getCod());
		/*
		for(var sRowClass in this.arrDocRows)
		{
			var oRow = this.arrDocRows[sRowClass];
			if(oRow && oRow.saveRowsToDB)
				this.arrDocRows[sRowClass].saveRowsToDB(extPar.doc);
		}
		*/
	}
	
	if (extPar && extPar.treePar)
	{
		extPar.treePar.sFWID = this.sFWID;
	}
	this.isAppplyClick = false;
	return true;	
}

function DpBaseDlg_getDocNop(sDoc)
{
	var ret = 0;
	var tblOp = OpenTable("select FNOP from ^cl_lnk where fdoc = " + sqlTo(sDoc) + " and fnop <> 0");
	if (tblOp.isEmpty())
	{
		tblOp.close();
		return 0;
	}
	
	if (Number(tblOp.recordCount) == 1)
	{
		var ret = Number(tblOp.getValue("FNOP"));
		tblOp.close();
		return ret;
	}
	tblOp.close();
	var pr = new Object();
	pr.ret = new Object();
	pr.doc = sDoc;
	pr.ret.fdoc = sDoc;
	pr.ret.fnop = 0;  
	showWindow("l_chooseclop.js",SW_MODAL,pr,"");
	return pr.ret.fnop;	
}


function DpBaseDlg_isSaving()
{
	return this.bSaving;
}

function DpBaseDlg_escape()
{	
	if (extPar)
		extPar.escape = true;	
	
	if(this.sMode=="MASS_EDIT")
	{
		FORM.close();
		return true;
	}	
	if(this.onEscape()==false)
	{
		return false;
	}
	else
	{
		var ret = handleEvent("onDialogEscape", this);
		if (this.doExit === false)
			return false;
		this.exit();
	}
}

function DpBaseDlg_exit()
{
	if(this.sMode=="MASS_EDIT")
	{
		FORM.close();
		return true;
	}
	this.onExit();
	
	if (this.docKey)
		lpProxy.getShellMap().remove(this.docKey);
	
	FORM.close();
}

function empty()
{
}

function DpBaseDlg_saveExt(bWithDB)
{
//-	var doMove = !extPar.tblSrc.isEmpty();
/*	if (extPar.mode != "EDIT")
	{
		extPar.tblSrc.requery();
	}
*/
	if(extPar.fwid)
		this.sFWID = extPar.fwid;
	for (var ctrl in this.extCtrlMap)
	{
		var alias = allt(ctrl.substr(0,ctrl.indexOf("_")));
		var label = allt(ctrl.substr(ctrl.indexOf("_") + 1));
		if (alias.substr(0,1) == "X" && alias.length == 1)
			alias = "#";
		if (alias == "" || label == "")
			continue;
		
		if (this.arrScAnalitics[ctrl])
		{
			var obj = this.arrScAnalitics[ctrl];
			
			//наш контрол - одна из аналитик счета
			switch(obj.an)
			{
				case 1:
					var newVal = this.arrSc[obj.grp].getCl1();
					break;
				case 2:
					var newVal = this.arrSc[obj.grp].getCl2();
					break;
				case 3:
					var newVal = this.arrSc[obj.grp].getCl3();
					break;
			}
		}
		else
		{
			var newVal = this.extCtrlMap[ctrl].getValue();
		}
		/*if (!newVal || newVal == null || String(newVal) == "")
		{
			continue;
		}*/
		if (newVal == null)
			continue;
		
		if (!this.isDoc && !this.isObj)
		{
/*
			if (extPar.mode != "ADD")
				extPar.tblSrc.setValue(alias + "." + label,newVal);
			else
			{
*/
				var etable = extPar.tblSrc.GetTie(alias);
				if (etable == null)
					return;
				
				etable.setValue(Number(this.sFWID),label,newVal);
//-			}
		}
		else
		{
			if (this.isDoc)
				extPar.doc.setExt(label,newVal);
			else
				extPar.dpObj.setExt(label,newVal);
		}
	}

	if (bWithDB === false)
		return;
	
	if (this.isDoc && extPar.doc.hasExt())
	{
		extPar.doc.saveExtToDB();
	}
	else if (this.isObj && extPar.dpObj.hasExt())
	{
		extPar.dpObj.saveExtToDB();
	}
}

function DpBaseDlg_saveDocRegAttrs(oDoc)
{
	if (!oDoc)
		oDoc = extPar.doc;
	var regs = oDoc.getRegNums();
	for (var i = 0; i < regs.length; i++)
	{
		try
		{
			var nReg = regs[i].Num;
			var sVid = (strIn("P",regs[i].getType())?"+":"-");
			
			var oCtrl = eval("NK_NUM_" + nReg);
			var value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"NK_NUM",value);
			
			oCtrl = eval("ISNOV1_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"ISNOV1",value == false);
			
			oCtrl = eval("NK_DAT_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"NK_DAT",value);
			
			if (sVid=="+")
			{
				oCtrl = eval("VYP_DATE_" + nReg);
				value = oCtrl.getValue();
				oDoc.setRegAttr(nReg,"VYP_DATE",value);
			}
			
			oCtrl = eval("OP_FORM_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"OP_FORM",value);
			
			oCtrl = eval("PR_COND_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"PR_COND",value);
			
			oCtrl = eval("VID_DOC_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"VID_DOC",value);
	/*		
			oCtrl = eval("GROUP_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"GROUP",value);
			value = oCtrl.getData("dp").getID();
			if (allt(value) != "")
				oDoc.setRegAttr(nReg,"IDCONTR",parseInt(value));
	*/
			if (getRegPar(sVid,"CODMNG") != 0)
			{
				oCtrl = eval("MNG_" + nReg);
				value = oCtrl.getValue();
				oDoc.setRegAttr(nReg,"MNG",value);
			}
			if (getRegPar(sVid,"CODZONE") != 0)
			{
				oCtrl = eval("ZONE_" + nReg);
				value = oCtrl.getValue();
				oDoc.setRegAttr(nReg,"ZONE",parseInt(value));
			}
			oCtrl = eval("TREASON_" + nReg);
			value = oCtrl.getValue();
			oDoc.setRegAttr(nReg,"TREASON",parseInt(value));

		}
		catch(e)
		{
			//alert(e, 2);
		}
	}
}

function DpBaseDlg_initSysPrint(oDpObject)
{
	include("objects\\DpPrintSelect.js");
	if (this.isDoc && typeof(btnSysPrint)!="undefined")
	{
		var oPrintSelect = new DpPrintSelect("DOC",oDpObject.sDocLbl);
		oPrintSelect.linkToButton(btnSysPrint);
		oPrintSelect.setPrintListener(this);
		extPar.doc.printSelect = oPrintSelect;
	}
}

function DpBaseDlg_setHelp(pluginID, helpID)
{
	if (typeof(btnHelp) == "undefined")
	{
		return;
	}
	if (helpID)
		helpID = pluginID + "." + helpID;
	else
		helpID = (IS_WEB?"org.debet.help":"org.debet.DebetApp.rcp") + "." + pluginID;
	
	
	var iconHelp = lpProxy.getData("icons/help-2.gif");
	if (iconHelp == null)
	{
		var imgData = new Packages.org.eclipse.swt.graphics.ImageData(rootDirectoryEx() + "icons/help-2.gif");
		imgData.transparentPixel = imgData.getPixel(0,0);
		iconHelp = new Packages.org.eclipse.swt.graphics.Image(null,imgData);
		lpProxy.setData("icons/help-2.gif", iconHelp);
	}
	btnHelp.getCtrl().setImage(iconHelp);
	btnHelp.getCtrl().setVisible(true);
	btnHelp.getCtrl().getParent().layout(true, true);
	this.displayHelp = new Function("PlatformUI.getWorkbench().getHelpSystem().displayHelp('" + helpID+ "');")
	
	if (typeOf(FORM) == "DpXMLDialog")
	{
		PlatformUI.getWorkbench().getHelpSystem().setHelp(FORM.getShell(), helpID);
		setButton(btnHelp,this, "displayHelp");
	}
}



function DpBaseDlg_runPrint(oFrmInfo)
{
	if (this.isDoc)
	{
		if (this.ctrlLinker)
			this.ctrlLinker.updateData(true);
		else if (ctrlLinker)
			ctrlLinker.updateData(true);
		extPar.doc.print(oFrmInfo.sFormLabel);
	}
}

function DpBaseDlg_setEscapeMsg(sMsg)
{
	FORM.setEscapeMsg(sMsg);
}

function HDAT_Valid()
{
	var dateCtrl = typeof(HDAT)=="object"? HDAT
		: typeof(FDOC_DAT)=="object"? FDOC_DAT
		: null;
		
	//if(!canUpdateDate(toScrObj(dateCtrl.value)))
	//	return false;

}

function ext_text_valid(oCtrl)
{
	var sVal = String(oCtrl.getValue()).trim();
	if(!sVal || sVal=="" || sVal=="0" || Number(sVal)==0)
	{
		WAIT(UR("Неприпустиме значення розширення|Недопустимое значение расширения"));
		oCtrl.setBackground(0xFFAAAA);
		setFocus(oCtrl);
		return false;
	}
	oCtrl.setBackground(0xFFFFFF);
	return true;
}

function ext_date_valid(oCtrl)
{
	var oVal = new Date(oCtrl.getValue());
	if(!oVal || differ(oVal, d00)==0)
	{
		WAIT(UR("Неприпустиме значення розширення|Недопустимое значение расширения"));
		setFocus(oCtrl);
		return false;
	}	
	return true;
}

list = null;


function main()
{
	list = new DpBaseDlg();
	list.load();	
	if (extPar && extPar.save_after_load)
		list.save();
	checkFreeMemory();
}

function DpBaseDlg_addExternalDocs()
{
	if(this.sMode=="MASS_EDIT")
		return;
	
	var tLinkDoc = OpenTable("s", "select * from ^doc_links " 
		+ " where fdoc = 'WD' and fmainwid = " + sqlTo(extPar.doc.getID()));
	if (!tLinkDoc.isEOF())
	{
		include("doc\\DpDoc.js");
		var rExtTab = FORM.addTab(UR("Зовнішні документи|Внешние документы"));
		var ExtTab = FORM.addScrolledComposite(rExtTab);
		if (IS_WEB)
		{
			var gl = new Packages.org.eclipse.swt.layout.GridLayout(3,false);
			ExtTab.setLayout(gl);
		}
		var i = 0;
		while (!tLinkDoc.isEOF())
		{
			var gd = new Packages.org.eclipse.swt.layout.GridData();
			gd.horizontalSpan = 1;
        	gd.widthHint = 400;
        	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
            gd.grabExcessHorizontalSpace = true;      
				
			var m = new Object();
			m.fdoc = tLinkDoc.getValue("fdoc");
			m.fnop = tLinkDoc.getValue("fnop");
			m.fdocwid = Number(tLinkDoc.getValue("fdocwid"));
			var oDoc = new DpDoc(m.fdoc,m.fnop);
			var bLoad = oDoc.loadByID(m.fdocwid)
			if (bLoad)
			{
				var ctrl = FORM.getDialogBuilder().addTextField(ExtTab, gd, oDoc.getVar("hrem") + " : ", "ctrl" + i, SWT.LEFT);
				ctrl.setValue(oDoc.getVar("hname"));
				ctrl.setData("DOCID", oDoc.getID());
				if (oDoc.getVar("hname") != "")
				{
					var obj = new Object();
					obj.showExtDoc = new Function("DpBaseDlg_showExtDoc(ctrl" + i + ")");
					ctrl.buttonHandler(obj,"showExtDoc");
					ctrl.setButton();
					if (IS_WEB)
					{
						gd = new Packages.org.eclipse.swt.layout.GridData();
						ctrl = FORM.getDialogBuilder().addButton(ExtTab,"Завантажити|Загрузить",gd, "btnexdoc" + i, SWT.LEFT);
						var obj = new Object();
						obj.showExtDoc = new Function("DpBaseDlg_uploadExtDoc(ctrl" + i + ")");
						ctrl.buttonHandler(obj,"showExtDoc");
					}
						
				}
			}
			tLinkDoc.MoveNext();
			i++;		 	
		}
		
		ExtTab.pack();
	}
	tLinkDoc.close();
}


function DpBaseDlg_showExtDoc(ctrl)
{

	var name = String(ctrl.getValue());
	var fldr = ctrl.getData("HFOLDER"); 
	var docID = String(Number(ctrl.getData("DOCID")));
	file = new DpFile(name);
	if (!file.exists())
	{
		file = new DpFile(name + ".doc");
	}
	
	if (!file.exists() && fldr && isDir(fldr))
	{
		file = new DpFile( fldr + "/" + name);
		if (!file.exists())
			file = new DpFile( fldr + "/" + name + ".doc");
	}		
	
	if (!file.exists() && getPar("OFFICEDIR") != "")
	{
		file = new DpFile( getPar("OFFICEDIR") + "/" + docID + "/" + name);
		if (!file.exists())
			file = new DpFile( getPar("OFFICEDIR") + "/" + docID + "/" + name + ".doc");
	}
	
	
	if (file.exists())	
	{
		if(IS_WEB)
			shellOpen(file.getAbsolutePath());
		else
			Packages.org.eclipse.swt.program.Program.launch(file.getAbsolutePath());
		//java.awt.Desktop.getDesktop().open(file);
	}
	else
	{
		alert(ru("Файл ","Файла ") + name + ru(" не найден"," не знайдено"))
	}	

}

function DpBaseDlg_uploadExtDoc(ctrl)
{

	var name = String(ctrl.getValue());
	var fldr = ctrl.getData("HFOLDER"); 
	var docID = String(Number(ctrl.getData("DOCID")));
	file = new DpFile(name);
	if (!file.exists())
	{
		file = new DpFile(name + ".doc");
	}
	
	if (!file.exists() && fldr && isDir(fldr))
	{
		file = new DpFile( fldr + "/" + name);
		if (!file.exists())
			file = new DpFile( fldr + "/" + name + ".doc");
	}		
	
	if (!file.exists() && getPar("OFFICEDIR") != "")
	{
		file = new DpFile( getPar("OFFICEDIR") + "/" + docID + "/" + name);
		if (!file.exists())
			file = new DpFile( getPar("OFFICEDIR") + "/" + docID + "/" + name + ".doc");
	}
	
	if (!file.exists())	
	{
		file = new DpFile( getPar("OFFICEDIR") + "/" + docID + "/" + name);		
	}
	uploadFileToFile(file.getAbsolutePath());

}


function DpBaseDlg_addTopicTab()
{
	if(this.sMode=="MASS_EDIT" || extPar.doc.sDocLbl=="TOPIC")
		return;
	/*
	var tbl = OpenTable("select * from ^DOC_LINKS " 
						+" where FDOC='TOPIC' "
							+" and FMAINWID="+ sqlTo(extPar.doc.getID())
						);
	include("doc\\DpDoc.js");
	var tab = FORM.addTab(UR("Топіки|Топики"));
	this.topicTab = FORM.addScrolledComposite(tab);
	this.topicTab.getLayout().numColumns = 3;
	while (!tbl.isEOF())
	{
		var doc = tbl.getValue("FDOC");
		var nop = tbl.getValue("FNOP");
		var docID = Number(tbl.getValue("FDOCWID"));
		var oDoc = new DpDoc(doc, nop);
		if (oDoc.loadByID(docID))
		{
			var topicDocNum = oDoc.getVar("HNOM");
			var topicCod = oDoc.getVar("HTOPIC");
			this.addTopicField(topicCod, docID);	
		}
		tbl.MoveNext();				 	
	}
	
	this.addTopicField();
	this.topicTab.pack();
	*/
		
	var tab = FORM.addTab(UR("Теми|Темы"), "TOPICSTAB");
	FORM.getTabFolder().setSelectionHandler(this, "topicsTab_listener");
	
	var dlgBuilder = FORM.getDialogBuilder();
	var gd = new Packages.org.eclipse.swt.layout.GridData();	
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
    gd.grabExcessHorizontalSpace = true;
    gd.verticalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
    gd.grabExcessVerticalSpace = true;
    
    this.topicsGrid = dlgBuilder.addGrid(tab, "topicsGrid", gd, true, false, true, false, false, false, false);
}

function DpBaseDlg_topicsTab_listener(tabItem)
{	
	if(tabItem.getData("ID")!="TOPICSTAB")
		return;
	
	if(this.topicsGrid && this.topicsGrid.getTable())
	{
		this.topicsGrid.getTable().requery();
		this.topicsGrid.refresh();
		return;
	}
	
	var tblTopics = OpenTable("select l.*, t.FTOPIC_TXT, t.FCAT_TXT, t.FMANAGER_TXT"
								+", t.FDOC_NUM, t.FBDAT, t.FEDAT "
							+" from ^DOC_LINKS l "
							+" inner join ^LISTTOPICS t on t.FWID=l.FDOCWID " 
							+" where l.FDOC='TOPIC' "
								+" and l.FMAINWID="+ sqlTo(extPar.doc.getID())
							);
	
	this.topicsGrid.FieldEx("FDOC_NUM", "№", 8);
	this.topicsGrid.FieldEx("FTOPIC_TXT", "Назва|Название", 10);
	this.topicsGrid.FieldEx("FCAT_TXT", "Категорія|Категория", 10);
	this.topicsGrid.FieldEx("FBDAT", "Відкрита|Открыта", 12);
	this.topicsGrid.FieldEx("FEDAT", "Закрита|Закрыта", 12);
	this.topicsGrid.FieldEx("FMANAGER_TXT", "Менеджер|Менеджер", 12);
	this.topicsGrid.setTable(tblTopics);
	this.topicsGrid.build();
	
	this.topicsGridMenuInit = topicsGridMenuInit;
	this.topicsGridMenuRun = topicsGridMenuRun;
	this.topicsGrid.loadMenuHandler(this, "topicsGridMenuInit");
	this.topicsGrid.selectMenuHandler(this, "topicsGridMenuRun");
}

function topicsGridMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	if(IsDblClick(oGrid))
	{
		if(tbl.getValue("FDOC"))
			topicsGridMenuRun("VIEW", oGrid);
		return true;
	}
		
	if(tbl.getValue("FDOC"))
	{
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
		oGrid.AddMenuItem("ADD", "Додати|Добавить");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
		oGrid.AddMenuItem("DEL", "Вилучити зв'язування|Удалить связку");
	}
	else
	{
		oGrid.AddMenuItem("ADD", "Додати|Добавить");
	}
}

function topicsGridMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();			
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FDOCWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
		
		case "ADD":
			var par = new Object();
			par.ret = new Object();
			par.ret.FDOC_NUM = null;
			par.ret.FWID = null;
			par.ret.FTOPIC = null;
			par.title = UR("Вибір теми|Выбор темы");
			par.doc = "TOPIC";
			par.nop = 0;
			showWindow("l_docekz.xml", SW_MODAL, par);
			if(par.escape)
				return;
			
			var oDoc = extPar.doc;	
			var m = new Object(); 
			m.FMAINWID = oDoc.getID();
			m.FDOCWID = par.ret.FWID;
			m.FDOC = "TOPIC";
			m.FNOP = 1;
			m.FISPARENT = true;
			m.FWID = GetUID();
			updateTable("^DOC_LINKS", m, true);
			
			var m = new Object(); 
			m.FMAINWID = par.ret.FWID;
			m.FDOCWID = oDoc.getID();
			m.FDOC = oDoc.sDocLbl;
			m.FNOP = oDoc.nNop;
			m.FISPARENT = false;
			m.FWID = GetUID();
			updateTable("^DOC_LINKS", m, true);
			
			oGrid.getTable().requery();
			oGrid.refresh();
			break;
			
		case "DEL":
			if(!confirm(UR("Вилучити зв'язування з темою?|Удалить связку с темой?")))
				return true;
			var tbl = oGrid.getTable();
			ExecuteSQL("delete from ^DOC_LINKS where FWID="+ tbl.getValue("FWID"));
			tbl.requery();
			oGrid.refresh();
			return true;
			break;
		
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FDOCWID"));
			if(!doc)
				return true;
			var oDoc = new DpDoc(doc, nop);
			var bRet = oDoc.edit(sID, id);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}

function DpBaseDlg_addTopicField(topicCod, docID)
{
	if(!this.topicTab)
		return;
	
	var gd = new Packages.org.eclipse.swt.layout.GridData();
	gd.horizontalSpan = 2;
	gd.widthHint = 400;
	gd.horizontalAlignment = Packages.org.eclipse.swt.layout.GridData.FILL;
    gd.grabExcessHorizontalSpace = true;
	
	var oTopic = new Object();
	oTopic.cod = topicCod;
	oTopic.docID = docID;
	
	var nID = this.arrTopic.length;
	var ctrl = FORM.getDialogBuilder().addTextField(this.topicTab, gd, "", "FTOPIC"+ nID, SWT.LEFT);
	var txt = topicTxt(topicCod);
	ctrl.setValue(txt);		
	var obj = new Object();
	obj.topicSelect = new Function("DpBaseDlg_topicSelect(FTOPIC" + nID +")");	
	ctrl.buttonHandler(obj, "topicSelect");
	ctrl.setButton();		
	ctrl.setData("DLG", this);
	ctrl.setData("NID", nID);		
	oTopic.ctrl = ctrl;
		
	var btnDel = FORM.getDialogBuilder().addButton(this.topicTab, "BTNDELTOPIC"+ nID, "");
	btnDel.setImage(rootDirectoryEx() +"icons/delete.gif");
	btnDel.getCtrl().setToolTipText(UR("Вилучити зв'язування|Удалить связку"));
	var obj = new Object();
	obj.topicDelete = new Function("topicDelete(BTNDELTOPIC" + nID +")");
	setButton(btnDel, obj, "topicDelete");
	btnDel.setData("DLG", this);
	btnDel.setData("NID", nID);
	oTopic.btnDel = btnDel;
	
	this.arrTopic[nID] = oTopic;
}

function topicDelete(ctrl)
{
	var nID = Number(ctrl.getData("NID"));
	var dlg = ctrl.getData("DLG");
	if(nID>=dlg.arrTopic.length-1)
		return;
	var oTopic = dlg.arrTopic[nID];
	oTopic.btnDel.getCtrl().dispose();
	oTopic.ctrl.getCtrl().dispose();
	oTopic.ctrl.getBtn().dispose();
	if(oTopic.docID)
	{
		ExecuteSQL("delete from ^DOC_LINKS "
				+" where (FDOCWID="+ oTopic.docID +" and FMAINWID="+ extPar.doc.getID() +") "
					+"or (FMAINWID="+ oTopic.docID +" and FDOCWID="+ extPar.doc.getID() +")"
				);
	}
	//dlg.topicTab.pack();
}

function DpBaseDlg_topicSelect(ctrl)
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FDOC_NUM = null;
	par.ret.FWID = null;
	par.ret.FTOPIC = null;
	par.title = UR("Вибір теми|Выбор темы");
	par.doc = "TOPIC";
	par.nop = 0;
	showWindow("l_docekz.xml", SW_MODAL, par);
	if(par.escape)
		return;
	
	ctrl.value = topicTxt(par.ret.FTOPIC);
	var nID = Number(ctrl.getData("NID"));
	var dlg = ctrl.getData("DLG");	
	if(nID==dlg.arrTopic.length-1)
	{
		dlg.addTopicField();
		dlg.topicTab.pack();
	}	
	
	var oTopic = dlg.arrTopic[nID];
	if(oTopic.docID)
	{
		ExecuteSQL("delete from ^DOC_LINKS "
				+" where (FDOCWID="+ oTopic.docID +" and FMAINWID="+ extPar.doc.getID() +") "
					+"or (FMAINWID="+ oTopic.docID +" and FDOCWID="+ extPar.doc.getID() +")"
				);
	}
	oTopic.docID = par.ret.FWID;
	dlg.arrTopic[nID] = oTopic;
	
	var oDoc = extPar.doc;	
	var m = new Object(); 
	m.FMAINWID = oDoc.getID();
	m.FDOCWID = par.ret.FWID;
	m.FDOC = "TOPIC";
	m.FNOP = 1;
	m.FISPARENT = true;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	var m = new Object(); 
	m.FMAINWID = par.ret.FWID;
	m.FDOCWID = oDoc.getID();
	m.FDOC = oDoc.sDocLbl;
	m.FNOP = oDoc.nNop;
	m.FISPARENT = false;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
}

function topicTxt(topicCod)
{
	if(!topicCod)
		return "";
	var oSnap = getSnap("select FTXT from ^CL cl "
						+" inner join ^CLRELCLCL rel on rel.FWID_CL=cl.FWID"
						+" where rel.FCL="+ getPar("CL_TOPIC")
							+" and rel.FCOD="+ sqlTo(topicCod)
						, false);
	if(oSnap)
		return oSnap[0];
	return "";
}


function DpBaseDlg_loadParentDocRows(oDoc)
{
	try
	{		
		var s = "\nDpBaseDlg_loadParentDocRows";
									
		var arrClass = oDoc.jDoc.getParentChilds();
		for(var i=0; i<arrClass.length; i++)
		{
			var sRowClass = arrClass[i];			
			if(!sRowClass)
				continue;
				
			var oRow = oDoc.jDoc.createChild(sRowClass);
			if(!oRow)
				continue;
			
			var sRowName = oRow.getName();
			var rowsTab = FORM.addTab(sRowName);
			var gridID = "grid_"+ sRowClass
			var rowGrid = FORM.getDialogBuilder().addGrid(rowsTab, gridID);
			var sRowDir = oRow.getClassDescriptionDir();
			var sRowListXml = sRowDir +"list.xml";
			if(isFile(sRowListXml))
			{
				rowGrid.setXMLDir(sRowDir);
				rowGrid.setXMLFile("list.xml");
			}
			
			if(isFile(sRowDir +"list.js"))
			{
				include(sRowDir +"list.js");
				if(this.arrDocRows[sRowClass]==null)
				{
					this.arrDocRows[sRowClass] = new Object();
					if(typeof(rowGridInit) == "function")
					{
						this.arrDocRows[sRowClass].rowGridInit = rowGridInit;
						rowGridInit(rowGrid, oDoc, this.sMode);
					}
					if(typeof(rowGridMenuInit) == "function")
						this.arrDocRows[sRowClass].rowGridMenuInit = rowGridMenuInit;
					if(typeof(rowGridMenuRun) == "function")
						this.arrDocRows[sRowClass].rowGridMenuRun = rowGridMenuRun;
					if(typeof(saveRowsToDB) == "function")
						this.arrDocRows[sRowClass].saveRowsToDB = saveRowsToDB;
				}
			}
			
			rowGrid.setData("ROWCLASS", sRowClass);
			rowGrid.build();		
			
			rowGrid.loadMenuHandler(this, "rowGridMenuInit");
			rowGrid.selectMenuHandler(this, "rowGridMenuRun");
			
			s += "\n>>> "+ sRowClass +" > "+ sRowName +" > "+ sRowListXml;
		}
		trace(s +"\n");	
	}
	catch(e)
	{
		alert("DpBaseDlg_loadParentDocRows"+ e, 2);
	}
}

function DpBaseDlg_rowGridMenuInit(oGrid)
{
	var sRowClass = oGrid.getData("ROWCLASS");
	if(!sRowClass)
		sRowClass = "ROW";
	
	var obj = this.arrDocRows[sRowClass];
	if(obj && obj.rowGridMenuInit)
	{
		if(obj.rowGridMenuInit(oGrid))
			return;
	}
	
	oGrid.AddMenuItem("ADD", "Додавання | Добавление");
	if (!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагування | Редактирование");
		oGrid.AddMenuItem("COPY", "Копіювання | Копирование");
		oGrid.AddMenuItem("DEL", "Видалення | Удаление");
	}
}

function DpBaseDlg_rowGridMenuRun(sID, oGrid)
{
	var oDoc = extPar.doc;
	var sRowClass = oGrid.getData("ROWCLASS");
	if(!sRowClass)
		sRowClass = "ROW";
	
	var rowID = Number(oGrid.getTable().getRowID());
	var sTmpTbl = oGrid.getTable().getTableName();
	
	var obj = this.arrDocRows[sRowClass];
	if(obj && obj.rowGridMenuRun)
	{
		if(obj.rowGridMenuRun(sID, oGrid))
			return;
	}
		
	switch(sID)
	{
	case "DEL":
		oDoc.deleteRow(sRowClass, rowID);
		oGrid.getTable().Delete();
		oGrid.getTable().requery();
		oGrid.refresh();	
		break;
	
	case "ADD": case "EDIT": case "COPY":
		var oDocRow;
		if(sID == "ADD")
			oDocRow = oDoc.createRow(sRowClass);
		else if(sID == "EDIT")
			oDocRow = oDoc.getRow(sRowClass, rowID);
		else if(sID == "COPY")
			oDocRow = oDoc.copyRow(sRowClass, rowID);			
		if(!oDocRow)
			break;
		var bOK = oDocRow.edit(sID)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				oDoc.appendRow(sRowClass, oDocRow)
				
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			oGrid.getTable().requery();
			
			oGrid.getTable().findByID(oDocRow.getID());
			oGrid.refresh();			
		}
		break;
	}
}